Package: geneClassifiers
Type: Package
Title: Application of gene classifiers
Version: 1.35.0
Authors@R: c(
    person("R","Kuiper",email="r.kuiper.emc@gmail.com",role=c("cre","aut"),comment = c(ORCID = "0000-0002-3703-1762"))
    )
Description: This packages aims for easy accessible application of
        classifiers which have been published in literature using an
        ExpressionSet as input.
URL: https://doi.org/doi:10.18129/B9.bioc.geneClassifiers
BugReports: https://github.com/rkuiper/geneClassifiers/issues
License: GPL-2
biocViews: GeneExpression, BiomedicalInformatics, Classification,
        Survival, Microarray
LazyData: true
Suggests: testthat
Depends: R (>= 3.6.0)
Imports: utils, methods, stats, Biobase, BiocGenerics
Collate: aaa.R allGenericFunctions.R Class_TransformationProcess.R
        Class_FixedExpressionData.R Class_ClassifierParameters.R
        Class_ClassifierResults.R zzz.R geneClassifiers.R
RoxygenNote: 6.1.1
Encoding: UTF-8
git_url: https://git.bioconductor.org/packages/geneClassifiers
git_branch: devel
git_last_commit: c28693f
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 21:14:08 UTC; biocbuild
Author: R Kuiper [cre, aut] (ORCID: <https://orcid.org/0000-0002-3703-1762>)
Maintainer: R Kuiper <r.kuiper.emc@gmail.com>

#' @aliases showClassifierList
#' @title Show classifier names and descriptions.
#'
#' @description \code{showClassifierList} gives a data.frame of all implemented classifiers.
#'
#' @param normalizations an optional text argument of one or more normalization methods in order to filter the classifiers to be shown.
#'
#' @return A data.frame with columns: 'name','normalizationMethod' and 'description'
#'
#' @details The names of the classifiers shown can be used as input for the \code{\link{runClassifier}} function and the \code{\link{getClassifier}} function.
#'
#' @family workflow functions
#'
#' @docType methods
#' @rdname showClassifierList-methods
#'
#' @examples
#' showClassifierList()
#' data(exampleMAS5)
#' myData <- setNormalizationMethod(exampleMAS5, 'MAS5.0',targetValue=500)
#' results <- runClassifier('UAMS70', myData)
#' getScores( results )
#' getClassifications( results )
#'
#' @export
showClassifierList <- function(normalizations) {
    registeredClassifiers <- lapply(.classifierHookList, function(x) {
        x()
    })
    registeredClassifiers <- t(simplify2array(registeredClassifiers))
    if (!missing(normalizations)) {
        normalizations <- match.arg(toupper(normalizations), getNormalizationMethods(), 
            several.ok = TRUE)
        registeredClassifiers <- registeredClassifiers[registeredClassifiers[, "normalizationMethod"] %in% 
            normalizations, , drop = FALSE]
    }
    return(registeredClassifiers)
}

#' @rdname getClassifier-methods
#' @aliases getClassifier,character-method
setMethod("getClassifier", signature = signature(value = "character"), definition = function(value) {
    classifierName <- match.arg(value, showClassifierList()[, "name"])
    idx <- which(showClassifierList()[, "name"] == classifierName)
    classifierParameters <- .classifierHookList[[idx]](infoOnly = FALSE)
    classifierParameters
})

#' @aliases setNormalizationMethod
#' @title Prepare data.
#'
#' @description \code{setNormalizationMethod} is to be called prior to running a classifier.
#'
#' @param expressionSet An object of class \code{\link{ExpressionSet}} containing the gene
#' expression data.
#' @param method A character string indicating the normalization that was applied to the data.
#' Possible values are given by \code{getNormalizationMethods()}.
#' @param ... see details.
#'
#' @return An object of class \code{\link{FixedExpressionData}}
#'
#' @details The \code{\link{FixedExpressionData}} class forms together with the
#' \code{\link{ClassifierParameters}} class the basis for input to the  \code{\link{runClassifier}}
#' function. The data inside the \code{\link{FixedExpressionData}}-class has to be stored as it is
#' right after normalization.  This function may require some additional arguments:
#' \itemize{
#' \item \code{isLog2Transformed = TRUE} Use this argument if the data already underwent a
#' log2transformation, as is common e.g. in case of MAS5.0 normalization.
#' \item \code{targetValue = value} This is a MAS5.0 specific argument. It is the sample intensity
#' mean when the lowest and highest 2\% of intensities are discarded. If only part of the original
#' expression set is given to this function, then this argument is required.
#' }
#'
#' @family workflow functions
#'
#' @docType methods
#' @rdname setNormalizationMethod-methods
#'
#' @examples
#' data(exampleMAS5)
#' myData <- setNormalizationMethod(exampleMAS5, 'MAS5.0',targetValue=500)
#' results <- runClassifier('EMC92', myData)
#' getScores( results )
#' getClassifications( results )
#'
#' @importFrom methods new
#' @export
setNormalizationMethod <- function(expressionSet, method, ...) {
    if (!inherits(expressionSet, "ExpressionSet")) {
        stop("Expect argument 'expressionSet' to be an object of type ExpressionSet")
    }
    method <- match.arg(toupper(method), getNormalizationMethods())
    dotList <- list(...)
    FixedExpressionData(normalizationMethod = method, expressionMatrix = exprs(expressionSet), 
        ...)
    
}

test_that("getNormalizationMethods() return valid methods",{
    expect_equal(getNormalizationMethods(),c("MAS5.0","GCRMA"));
}
)


test_that("showClassifierList returns valid matrix (with and without argument)",{
    ok<-TRUE;
    cl<-showClassifierList();
    ok<-ok & is.matrix(cl)
    if (ok) {
        ok<- ok & length(intersect(c("name","normalizationMethod","description"),colnames(cl)))==3
    }
    if (ok) {
      cl<-showClassifierList("MAS5.0");
      ok<- ok & length(intersect(c("name","normalizationMethod","description"),colnames(cl)))==3
    }
    expect_true(ok)
})




test_that("getClassifier function with signture ('character') must return object of class 'ClassifierParameters'",{
    myClassifier<-getClassifier("EMC92")
    expect_true(is(myClassifier,"ClassifierParameters"))
})

test_that("setNormalizationMethod function should return an object of 'FixedExpressionData'",{
    eset<-Biobase::ExpressionSet(matrix(seq(100)+1e6,ncol=10)) 
    eset.fixed <- setNormalizationMethod(eset, "MAS5.0",targetValue=500)
    expect_true(is(eset.fixed,"FixedExpressionData"))
})

test_that("setNormalizationMethod must receive an ExpressionSet",{
    mat<-matrix(seq(100)+1e6,ncol=10)
    expect_error(is(setNormalizationMethod(mat, "MAS5.0"),"to be an object of type ExpressionSet"))
})

setOldClass("package_version")


############################################################## 
#' Obtain the weighting type used to obtain a classifier result.
#'
#' \code{getWeightingTypes} returns weigthing type 
#' 
#'
#' @return either 'complete' or 'reweighted'
#'
#' @family classifier results
#'
#' @export
#' @docType methods
#' @rdname getWeightingType-methods
#'
#' @examples
#' getWeightingTypes()

getWeightingTypes <- function() {
    return(c("complete", "reweighted"))
}

#' @name ClassifierResults
#' @title An S4 class to store classifier results.
#'
#'
#' @description  This class stores classifier results as obtained after running
#' the \code{\link{runClassifier}} function.
#'
#' @slot classifierParameters An object of class \code{\link{ClassifierParameters}}
#' in which the applied classifier parameters are stored.
#' @slot score A numeric vector of resulting classifier scores
#' @slot batchCorrection A character vector indicating wheter batch correction was applied
#' @slot weightingType A character string indicating wheter the weighting type was complete
#' (i.e. no missing data), reweighted (i.e. missing data was handled based on correction
#' using the covariance structure in the classifiers training data), or reduced (i.e. missing
#' data but not reweighting the original probeset weighting)
#' @slot .geneClassifierVersion An object of class \code{\link{package_version}}

setClass("ClassifierResults", representation = representation(classifierParameters = "ClassifierParameters", 
    score = "numeric", batchCorrection = "logical", weightingType = "character", 
    .geneClassifierVersion = "package_version"), prototype = list(.geneClassifierVersion = packageVersionInternal()))

#' @importFrom methods validObject
setValidity("ClassifierResults", function(object) {
    errTxt <- vector()
    if (length(getWeightingType(object)) != 1) {
        errTxt <- c(errTxt, "More than one weightingTypes received")
    } else if (!getWeightingType(object) %in% getWeightingTypes()) {
        errTxt <- c(errTxt, paste0("Weigthingtypes must be one of: ", paste(getWeightingTypes(), 
            collapse = ", ")))
    }
    validObject(getClassifier(object), complete = TRUE)
    
    if (length(errTxt) > 0) {
        return(errTxt)
    }
    return(TRUE)
})


setMethod("ClassifierResults", signature = signature(weightingType = "character", 
    batchCorrection = "logical", score = "numeric", classifierParameters = "ClassifierParameters"), 
    definition = function(weightingType, batchCorrection, score, classifierParameters) {
        new("ClassifierResults", classifierParameters = classifierParameters, score = score, 
            batchCorrection = batchCorrection, weightingType = weightingType)
    })

#' @rdname getScores-methods
#' @aliases getScores,ClassifierResults-method
#' @export
setMethod("getScores", signature = signature("ClassifierResults"), definition = function(object) {
    return(object@score)
})

#' @rdname getClassifier-methods
#' @aliases getClassifier,ClassifierResults-method
#' @export
setMethod("getClassifier", signature = signature(value = "ClassifierResults"), definition = function(value) {
    return(value@classifierParameters)
})


#' @rdname getBatchCorrection-methods
#' @aliases getBatchCorrection,ClassifierResults-method
#' @export
setMethod("getBatchCorrection", signature = signature(object = "ClassifierResults"), 
    definition = function(object) {
        return(object@batchCorrection)
    })


#' @rdname getWeightingType-methods
#' @aliases getWeightingType,ClassifierResults-method
#' @export
setMethod("getWeightingType", signature = signature(object = "ClassifierResults"), 
    definition = function(object) {
        return(object@weightingType)
    })

#' @rdname getName-methods
#' @aliases getName,ClassifierResults-method
#' @export
setMethod("getName", signature = signature(object = "ClassifierResults"), definition = function(object) {
    return(getName(getClassifier(object)))
})

#' @rdname getClassifications-methods
#' @aliases getClassifications,ClassifierResults-method
#' @export
#' @importFrom utils as.roman
setMethod("getClassifications", signature = signature(object = "ClassifierResults"), 
    definition = function(object) {
        boundaries <- getDecisionBoundaries(getClassifier(object))
        y <- getScores(object)
        classifications <- vapply(X = boundaries, FUN = function(x, y) {
            y > x
        }, FUN.VALUE = rep(FALSE, length(y)), y = y)
        classifications <- factor(rowSums(classifications), levels = seq(from = 0, 
            to = length(boundaries)), labels = paste("Risk", as.roman(1 + seq(from = 0, 
            length(boundaries))), sep = "-"), ordered = TRUE)
        return(classifications)
    })

setMethod("show", signature = signature(object = "ClassifierResults"), definition = function(object) {
    classifications <- getClassifications(object)
    riskGroup <- table(classifications)
    cat("Note: Research use only\n")
    cat("Classifier:", getName(object), "\n")
    decisionBoundaries <- getDecisionBoundaries(getClassifier(object))
    for (boundary in decisionBoundaries) {
        cat("\t", paste(">", boundary, ":", names(riskGroup)[-1]), "\n")
    }
    print(riskGroup)
    cat("\n\tBatch corrected   :", c("no", "yes")[getBatchCorrection(object) + 1], 
        "\n")
    cat("\tweighting type      :", getWeightingType(object), "\n")
    cat("----------------\n")
})

setOldClass("package_version")

setClass("TransformationProcess", representation(name = "character", values = "environment", 
    hook = "function", .geneClassifierVersion = "package_version"), prototype = list(.geneClassifierVersion = packageVersionInternal()))

#' @importFrom utils packageVersion packageName
setMethod("TransformationProcess", signature(name = "character", values = "ANY"), 
    definition = function(name, values, ...) {
        if (!name %in% c("LOG", "SHIFTPERPROBE", "LOWERTRUNCATE", "MULTIPLYPERPROBE")) {
            stop("Trying to initialze an unknown process:", name, ".")
        }
        
        procValues <- new.env()
        procValues[["processes"]] <- list()
        
        if (name == "LOG") {
            if (length(values) == 0) {
                stop("LOG TransformationProcess values argument must be given: the base number for the logarithm.")
            }
            if (length(values) != 1) {
                stop("LOG TransformationProcess only takes one value: the base number for the logarithm.")
            }
            if (!is.numeric(values)) {
                stop("LOG TransformationProcess requires a numeric base value")
            }
            if (values <= 0) {
                stop("LOG TransformationProcess requires a positive numeric base value")
            }
            procValues[["processes"]] <- values
            hook <- function(object, expressionMat) {
                expressionMat[] <- log(expressionMat, getValues(object))
                return(expressionMat)
            }
        }
        if (name == "SHIFTPERPROBE") {
            if (!is.numeric(values) | !is.vector(values)) {
                stop("SHIFTPERPROBE TransformationProcess requires a numeric value or numeric vector named by probe names when applied.")
            }
            if (length(values) > 1 & is.null(names(values))) {
                stop("SHIFTPERPROBE TransformationProcess requires a numeric value or numeric vector named by probe names when applied.")
            }
            procValues[["processes"]] <- values
            hook <- function(object, expressionMat) {
                values <- getValues(object)
                if (length(values) == 1 & all(is.null(names(values)))) {
                  values <- rep(values, nrow(expressionMat))
                  names(values) <- rownames(expressionMat)
                }
                intersectingNames <- intersect(names(values), rownames(expressionMat))
                expressionMat[intersectingNames, ] <- expressionMat[intersectingNames, 
                  ] + values[intersectingNames]
                return(expressionMat)
            }
        }
        if (name == "LOWERTRUNCATE") {
            if (length(values) != 1) {
                stop("LOWERTRUNCATE TransformationProcess only takes one value: the value below which to truncate.")
            }
            if (!is.numeric(values)) {
                stop("LOWERTRUNCATE TransformationProcess requires a numeric value")
            }
            procValues[["processes"]] <- values
            hook <- function(object, expressionMat) {
                expressionMat[expressionMat <= getValues(object)] <- getValues(object)
                return(expressionMat)
            }
        }
        if (name == "MULTIPLYPERPROBE") {
            if (!is.numeric(values) | !is.vector(values)) {
                stop("MULTIPLYPERPROBE TransformationProcess requires a numeric value or numeric vector named by probe names when applied.")
            }
            if (length(values) > 1 & is.null(names(values))) {
                stop("MULTIPLYPERPROBE TransformationProcess requires a numeric value or numeric vector named by probe names when applied.")
            }
            procValues[["processes"]] <- values
            hook <- function(object, expressionMat) {
                values <- getValues(object)
                if (length(values) == 1 & all(is.null(names(values)))) {
                  values <- rep(values, nrow(expressionMat))
                  names(values) <- rownames(expressionMat)
                }
                intersectingNames <- intersect(names(values), rownames(expressionMat))
                expressionMat[intersectingNames, ] <- expressionMat[intersectingNames, 
                  ] * values[intersectingNames]
                return(expressionMat)
            }
        }
        lockEnvironment(procValues, bindings = TRUE)
        new("TransformationProcess", name = name, values = procValues, hook = hook)
    })

setMethod("runProcess", signature = signature(object = "TransformationProcess", expressionMat = "matrix"), 
    definition = function(object, expressionMat) {
        return(object@hook(object, expressionMat))
    })

setMethod("getValues", signature = signature(object = "TransformationProcess"), definition = function(object) {
    return(object@values[["processes"]])
})

#' @rdname getName-methods
#' @aliases getName,TransformationProcess-method
setMethod("getName", signature = signature(object = "TransformationProcess"), definition = function(object) {
    return(object@name)
})

#' @aliases getNormalizationMethods
#' @title Show currenly implemented normalization methods.
#'
#' @description \code{getNormalizationMethods} returns a character vector of 
#' currenlty available normalization methods.
#'
#'
#' @details The given normlization methods can be used in the
#'
#' @family workflow functions
#'
#' @docType methods
#' @rdname getNormalizationMethod-methods
#'
#' @examples
#' data(exampleMAS5)
#'
#' showClassifierList()
#' getNormalizationMethods()
#'
#' myData <- setNormalizationMethod(exampleMAS5, 'MAS5.0',targetValue=500)
#' results <- runClassifier('UAMS70', myData)
#'
#' getScores( results )
#' getClassifications( results )
#'
#' @export
getNormalizationMethods <- function() {
    ## By convention uppercase
    return(c("MAS5.0", "GCRMA"))
}

#'Example MAS5.0 ExpressionSet
#'
#'An \code{\link{ExpressionSet}}. The data contains a sample of gene expression 
#'data from patients included in the HOVON65/GMMG-HD4 trial on multiple myeloma. 
#'The data was MAS5.0 normalized to a target value of 500.
#'
"exampleMAS5"

setOldClass("package_version")

#' @name FixedExpressionData
#' @title An S4 class to store classifier parameters.
#'
#' @description  This class stores gene expression data together with 
#' information on the normalization method and additional normalization related 
#' parameters. In order to ensure the data is not manipulated in unforeseen 
#' ways, manipulation is strictly controled through adding transformations 
#' which are predefined in the \code{TransformationProcess}-class. Upon reading
#' the data by the \code{exprs} function, the transformations areperformed in
#' the order the were added.
#'
#' @slot normalizationMethod A character string indicating the normalization
#' method that was applied to the data. Possible values are give by 
#' \code{\link{getNormalizationMethods}}.
#' @slot expressionEnvironment A locked environment in which the expression
#' matrix is stored.
#' @slot normalizationParameters A list with normalization specific values.
#' @slot transformationProcess A locked environment to which the transformation
#' processes are added.
#' @slot .geneClassifierVersion An object of class \code{\link{package_version}}
setClass("FixedExpressionData", representation = representation(normalizationMethod = "character", 
    expressionEnvironment = "environment", normalizationParameters = "list", transformationProcess = "environment", 
    .geneClassifierVersion = "package_version"), prototype = list(expressionEnvironment = as.environment(list(expressionMatrix = matrix(numeric(0), 
    ncol = 0, nrow = 0))), transformationProcess = as.environment(list(processes = list())), 
    .geneClassifierVersion = packageVersionInternal()))
setValidity("FixedExpressionData", function(object) {
    
    errTxt <- vector()
    if (!any(getNormalizationMethod(object) %in% getNormalizationMethods()) | length(getNormalizationMethod(object)) != 
        1) {
        errTxt <- c(errTxt, "Unknown normalization method")
    }
    if (!is.list(getTransformationProcesses(object))) {
        errTxt <- c(errTxt, "Unknown transformationProcess type")
    }
    if ("MAS5.0" %in% getNormalizationMethod(object)) {
        if (is.null(getNormalizationParameters(object)[["targetValue"]])) {
            errTxt <- c(errTxt, "targetValue must be given for MAS5.0")
        }
    }
    
    if (!is.matrix(rawExprs(object))) {
        errTxt <- c(errTxt, "'expressionMatrix' must be a numeric matrix.")
    }
    if (mode(rawExprs(object)) != "numeric") {
        errTxt <- c(errTxt, "'expressionMatrix' must be numeric.")
    }
    if (any(is.na(rawExprs(object)))) {
        errTxt <- c(errTxt, "NA values found in expression matrix.")
    }
    if (nrow(object) > 0) {
        if (is.null(rownames(object))) {
            errTxt <- c(errTxt, "'expressionMatrix' must have row names.")
        } else if (sum(duplicated(rownames(object))) > 0) {
            errTxt <- c(errTxt, "duplicated row names found.")
        }
    }
    if (ncol(object) > 0) {
        if (is.null(colnames(object))) {
            errTxt <- c(errTxt, "'expressionMatrix' must have column names.")
        } else if (sum(duplicated(colnames(object))) > 0) {
            errTxt <- c(errTxt, "duplicated column names found.")
        }
    }
    
    if (length(errTxt) > 0) {
        return(errTxt)
    }
    return(TRUE)
})

#' @importFrom utils packageVersion packageName
#' @importFrom stats quantile
setMethod("FixedExpressionData", signature = signature(normalizationMethod = "character", 
    expressionMatrix = "matrix"), definition = function(normalizationMethod, expressionMatrix, 
    ...) {
    isLog2Transformed <- FALSE  ##Assumption to be checked below
    targetValue <- NULL
    normalizationParameters <- list()
    
    ## process argument list
    dotList <- list(...)
    arg.isLog2Transformed <- NULL
    arg.targetValue <- NULL
    if (!is.null(dotList[["isLog2Transformed"]])) {
        if (!is.logical(dotList[["isLog2Transformed"]])) {
            stop("'isLog2Transformed' argument must be either TRUE of FALSE")
        }
        arg.isLog2Transformed <- dotList[["isLog2Transformed"]]
    }
    if (!is.null(dotList[["targetValue"]])) {
        if (!is.numeric(dotList[["targetValue"]])) {
            stop("'targetValue' argument must be numeric")
        }
        if (dotList[["targetValue"]] <= 0) {
            stop("'targetValue' argument must >0")
        }
        arg.targetValue <- dotList[["targetValue"]]
    }
    
    if (mode(expressionMatrix) != "numeric") {
        stop("'expressionMatrix' argument must be a numeric matrix.")
    }
    if (any(is.na(expressionMatrix))) {
        stop("NA values found in expression matrix.")
    }
    normalizationMethod <- match.arg(normalizationMethod, getNormalizationMethods())
    .getTargetValue <- function(expressionMatrix) {
        ## expressionMatrix must be not log2 transformed!
        e <- t(expressionMatrix)
        q <- apply(e, 1, quantile, c(0.02, 0.98), type = 2)
        naMat <- (e >= q[1, ] & e <= q[2, ])
        naMat[!naMat] <- NA
        targetValue <- unique(signif(rowMeans(naMat * e, na.rm = TRUE), 6))
        ## differs between samples -> return NULL
        if (length(targetValue) != 1) {
            targetValue <- NULL
        }
        return(targetValue)
    }
    .isAlreadylog2Transformed.check <- function(expressionMatrix) {
        storedSeed <- .Random.seed
        set.seed(1)
        aSample <- sample(expressionMatrix, 10000, replace = TRUE)
        .Random.seed <- storedSeed
        isLog2Transformed <- as.logical(quantile(aSample, 0.75, na.rm = TRUE) < 30 | 
            any(expressionMatrix < 0))
        return(isLog2Transformed)
    }
    
    ## Normalization method specific code:
    if (normalizationMethod == "MAS5.0") {
        isLog2Estimate <- .isAlreadylog2Transformed.check(expressionMatrix)
        ## if arg.isLog2Transformed given, warn if discordant with data
        if (!is.null(arg.isLog2Transformed)) {
            isLog2Transformed <- arg.isLog2Transformed
            if (arg.isLog2Transformed != isLog2Estimate) {
                warning("Reconsider argument isLog2Transformed = ", arg.isLog2Transformed)
            }
        } else {
            ## Assume estimate is correct and warn if estimate is TRUE
            isLog2Transformed <- isLog2Estimate
            if (isLog2Estimate == TRUE) {
                warning("The data seems to be log2 transformed. If this is incorrect, please provide the logical argument 'isLog2Transformed=FALSE'.")
            }
        }
        if (isLog2Transformed) 
            expressionMatrix[] <- 2^expressionMatrix
        
        calculatedTargetValue <- .getTargetValue(expressionMatrix)
        if (!is.null(arg.targetValue)) {
            targetValue <- arg.targetValue
            if (!is.null(calculatedTargetValue)) {
                if (arg.targetValue != calculatedTargetValue) {
                  warning("Using the given targetValue, but it does not correspond to the observed targetValue in the data of ", 
                    calculatedTargetValue, ".")
                }
            }
        } else if (is.null(arg.targetValue) & is.null(calculatedTargetValue)) {
            stop("Cannot determine the targetValue that was used for MAS5.0. Please provide the right 'targetValue=' as an argument.")
        } else if (is.null(arg.targetValue) & !is.null(calculatedTargetValue)) {
            targetValue <- calculatedTargetValue
        }
        normalizationParameters[["targetValue"]] <- targetValue
    }
    if (normalizationMethod == "GCRMA") {
    }
    object <- new("FixedExpressionData", normalizationMethod = normalizationMethod, 
        normalizationParameters = normalizationParameters)
    explicitlyChangeExprs(object) <- expressionMatrix
    return(object)
    
})

setMethod("show", signature = "FixedExpressionData", definition = function(object) {
    cat("____________________\n")
    cat("Fixed expression set\n\n")
    cat("Normalization method: ", getNormalizationMethod(object), "\n")
    cat("Number of samples   : ", dim(object)[2], "\n")
    cat("Number of features  : ", dim(object)[1], "\n")
    tp <- getTransformationProcesses(object)
    if (length(tp) > 0) {
        tpNames <- lapply(getTransformationProcesses(object), getName)
        tpNames <- paste(unlist(tpNames), collapse = "; ")
        cat("Applied transformation processes: ", tpNames, "\n")
    }
})

#' @importFrom methods new
#' @importFrom Biobase copyEnv
setMethod("addTransformationProcess", signature = signature(object = "FixedExpressionData", 
    name = "character"), definition = function(object, name, values, ...) {
    process <- TransformationProcess(name = name, values = values)
    aData <- copyEnv(object@transformationProcess)
    curLen <- length(aData[["processes"]])
    aData[["processes"]][[curLen + 1]] <- process
    lockEnvironment(aData, bindings = TRUE)
    object@transformationProcess <- aData
    return(object)
})

setMethod("getTransformationProcesses", signature = signature(object = "FixedExpressionData"), 
    definition = function(object) {
        return(object@transformationProcess[["processes"]])
    })

#' @importFrom Biobase copyEnv
setMethod("removeTransformationProcesses", signature = signature(object = "FixedExpressionData"), 
    definition = function(object, n = 1) {
        aData <- copyEnv(object@transformationProcess)
        curLen <- length(aData[["processes"]])
        n <- min(n, curLen)
        aData[["processes"]] <- aData[["processes"]][seq_len(max(0, curLen - n))]
        lockEnvironment(aData, bindings = TRUE)
        object@transformationProcess <- aData
        return(object)
    })

#' @rdname getNormalizationMethod-methods
#' @aliases getNormalizationMethod,FixedExpressionData-method
#' @export
setMethod("getNormalizationMethod", signature = signature("FixedExpressionData"), 
    definition = function(object) {
        object@normalizationMethod
    })

setMethod("getNormalizationParameters", signature = signature("FixedExpressionData"), 
    definition = function(object) {
        object@normalizationParameters
    })

#' @rdname getTargetValue-methods
#' @aliases getTargetValue,FixedExpressionData-method
#' @export
setMethod("getTargetValue", signature = signature("FixedExpressionData"), definition = function(object) {
    return(getNormalizationParameters(object)[["targetValue"]])
})

#' @importFrom methods validObject
setReplaceMethod("setTargetValue", signature = signature(object = "FixedExpressionData", 
    value = "numeric"), definition = function(object, value) {
    ## Replaces the rawexpression data with the new targetvalue
    if (!getNormalizationMethod(object) %in% c("MAS5.0")) {
        stop("Function 'setTargetValue' does only apply to MAS5.0 normalized data")
    }
    currentTargetValue <- getTargetValue(object)
    e <- rawExprs(object)
    explicitlyChangeExprs(object) <- e * value/currentTargetValue
    object@normalizationParameters[["targetValue"]] <- value
    validObject(object)
    return(object)
})

setMethod("getExpressionEnvironment", signature = signature("FixedExpressionData"), 
    definition = function(object) {
        return(object@expressionEnvironment)
    })

#' @importMethodsFrom Biobase exprs
setMethod("exprs", signature = signature("FixedExpressionData"), definition = function(object) {
    e <- rawExprs(object)
    processes <- getTransformationProcesses(object)
    for (process in processes) {
        e <- runProcess(process, e)
    }
    return(e)
})

setMethod("rawExprs", signature = signature("FixedExpressionData"), definition = function(object) {
    e <- getExpressionEnvironment(object)[["expressionMatrix"]]
    return(e)
})

############################################################## 
#' Dimensions of an Object
#'
#' Retrieve the dimension of an object.
#'
#' @param x an R object, for example a matrix, array or data frame.
#'
#' @return Retrieves the 'dim attribute of the object.  It is 'NULL' or a
#'    vector of mode 'integer'.
#'
#' @family fixed data information extraction functions
#'
#' @export
#' @docType methods
#' @rdname dim-methods
#' @aliases dim,FixedExpressionData-method
#' @export
#'
#' @examples
#' data(exampleMAS5)
#' myData <- setNormalizationMethod(exampleMAS5, 'MAS5.0', targetValue=500)
#' dim(myData)
#' dim(myData[1:10,1:3])
setMethod("dim", signature = signature("FixedExpressionData"), definition = function(x) {
    return(dim(rawExprs(x)))
})

#' @importMethodsFrom BiocGenerics rownames
setMethod("rownames", signature = signature(x = "FixedExpressionData"), definition = function(x) {
    return(rownames(rawExprs(x)))
})

#' @importMethodsFrom BiocGenerics colnames
setMethod("colnames", signature = signature(x = "FixedExpressionData"), definition = function(x) {
    return(colnames(rawExprs(x)))
})

############################################################## 
#' Extract
#'
#' Extract Parts of an Object
#'
#' @param x An object of class \code{\link{FixedExpressionData}}
#' @param i the rows index
#' @param j the column index
#' @param drop unused
#' @param ... unused
#' @return An object of class \code{\link{FixedExpressionData}}
#'
#' @family fixed data information extraction functions
#'
#' @export
#' @docType methods
#' @rdname bracket-methods
#'
#' @examples
#' data(exampleMAS5)
#' myData <- setNormalizationMethod(exampleMAS5, 'MAS5.0', targetValue=500)
#' dim(myData)
#' dim(myData[1:10,1:3])
#' dim(myData[[1:10,1:3]])
#' @export
setMethod("[", signature = signature(x = "FixedExpressionData", i = "ANY", j = "ANY"), 
    definition = function(x, i, j, ...) {
        return(x[[i, j, drop = FALSE]])
    })


#' @rdname bracket-methods
#' @aliases bracket,FixedExpressionData-method
#' @export
setMethod("[", signature = signature(x = "FixedExpressionData", i = "ANY", j = "missing"), 
    definition = function(x, i, j, ...) {
        return(x[[i, seq_len(ncol(x)), drop = FALSE]])
    })



#' @rdname bracket-methods
#' @aliases bracket,FixedExpressionData-method
#' @export
setMethod("[", signature = signature(x = "FixedExpressionData", i = "missing", j = "ANY"), 
    definition = function(x, i, j, ...) {
        return(x[[seq_len(nrow(x)), j, drop = FALSE]])
    })


#' @rdname bracket-methods
#' @aliases bracket,FixedExpressionData-method
#' @export
setMethod("[[", signature = signature(x = "FixedExpressionData", i = "ANY", j = "missing"), 
    definition = function(x, i, j, ...) {
        return(x[[i, seq_len(ncol(x)), drop = FALSE]])
    })

#' @rdname bracket-methods
#' @aliases bracket,FixedExpressionData-method
#' @export
setMethod("[[", signature = signature(x = "FixedExpressionData", i = "missing", j = "ANY"), 
    definition = function(x, i, j, ...) {
        return(x[[seq_len(nrow(x)), j, drop = FALSE]])
    })

#' @rdname bracket-methods
#' @aliases bracket,FixedExpressionData-method
#' @importFrom methods validObject
#' @export
setMethod("[[", signature = signature(x = "FixedExpressionData", i = "ANY", j = "ANY"), 
    definition = function(x, i, j, ...) {
        
        oldProcesses <- getTransformationProcesses(x)
        
        newObject <- new("FixedExpressionData", normalizationMethod = getNormalizationMethod(x), 
            normalizationParameters = getNormalizationParameters(x))
        explicitlyChangeExprs(newObject) <- rawExprs(x)[i, j, drop = FALSE]
        for (process in oldProcesses) {
            newObject <- addTransformationProcess(newObject, name = getName(process), 
                values = getValues(process))
        }
        validObject(newObject)
        return(newObject)
    })

#' @importFrom methods validObject
#' @importFrom Biobase copyEnv
setReplaceMethod("explicitlyChangeExprs", signature = signature(object = "FixedExpressionData", 
    value = "matrix"), definition = function(object, value) {
    
    # if (!all(dim(value)==dim(object))) stop('New and old expression matrices do not
    # have similar dimensions.')
    aData <- copyEnv(getExpressionEnvironment(object))
    aData[["expressionMatrix"]] <- value
    lockEnvironment(aData, bindings = TRUE)
    object@expressionEnvironment <- aData
    validObject(object)
    return(object)
})

test_that("getNormalizationMethods() return valid methods",{
    expect_equal(length(intersect(c("MAS5.0","GCRMA"),getNormalizationMethods())),2);
}
)

test_that("Checking FixedExpressionData Class",{
    expect_true(is(new("FixedExpressionData"),"FixedExpressionData")) ##Empty unusable object    
})


test_that("Creating FixedExpressionData with constructor function signature(normalizationMethod='character',expressionMatrix='matrix')",{
    mat<-matrix(rep("A",100),ncol=10)
    expect_error(FixedExpressionData("MAS5",mat),"must be a numeric matrix")
    mat<-matrix(rep(1e16,100),ncol=10)
    expect_error(FixedExpressionData("MAS5",mat),"must have row names")
    expect_error(FixedExpressionData("MAS5",mat),"must have column names")
    mat<-matrix(rep(1e16,100),ncol=10);rownames(mat)<-rep("A",nrow(mat))
    expect_error(FixedExpressionData("MAS5",mat),"must have column names")
    mat<-matrix(rep(1e16,100),ncol=10);colnames(mat)<-rep("A",ncol(mat))
    expect_error(FixedExpressionData("MAS5",mat),"must have row names")

    mat<-matrix(rep(1e16,100),ncol=10);colnames(mat)<-rep("A",ncol(mat));rownames(mat)<-rep("A",nrow(mat))
    expect_error(FixedExpressionData("MAS5",mat),"duplicated row names found")
    expect_error(FixedExpressionData("MAS5",mat),"duplicated column names found")

    mat<-matrix(rep(1e16,100),ncol=10);colnames(mat)<-letters[1:10];rownames(mat)<-rep("A",nrow(mat))
    expect_error(FixedExpressionData("MAS5",mat),"duplicated row names found")

    mat<-matrix(rep(1e16,100),ncol=10);colnames(mat)<-rep("A",ncol(mat));rownames(mat)<-letters[1:10]
    expect_error(FixedExpressionData("MAS5",mat),"duplicated column names found")
    
    mat<-matrix(rep(1e16,100),ncol=10);colnames(mat)<-letters[1:10];rownames(mat)<-letters[1:10];mat[3]<-NA
    expect_error(FixedExpressionData("MAS5",mat),"NA values found in expression matrix")
   
    mat<-matrix(rep(1,100),ncol=10);colnames(mat)<-letters[1:10];rownames(mat)<-letters[1:10]
    expect_warning({
        eset.fixed<-FixedExpressionData("MAS5",mat)
        expect_true(is(eset.fixed,"FixedExpressionData"))
    },"The data seems to be log2 transformed")
    
    mat<-matrix(rep(1,100)+1e6,ncol=10);colnames(mat)<-letters[1:10];rownames(mat)<-letters[1:10]
    expect_warning({
        eset.fixed<-FixedExpressionData("MAS5",mat,isLog2Transformed=TRUE)
        expect_true(is(eset.fixed,"FixedExpressionData"))
    },"Reconsider argument isLog2Transformed = TRUE")
    
    mat<-matrix(rep(1,100),ncol=10);colnames(mat)<-letters[1:10];rownames(mat)<-letters[1:10]
    expect_warning({
        FixedExpressionData("MAS5",mat,isLog2Transformed=FALSE)
        expect_true(is(eset.fixed,"FixedExpressionData"))
    },"Reconsider argument isLog2Transformed = FALSE")
  
    mat<-matrix(rep(1,100)+1e6,ncol=10);colnames(mat)<-letters[1:10];rownames(mat)<-letters[1:10]
    expect_warning(FixedExpressionData("MAS5",mat,targetValue=500),"Using the given targetValue, but it does not correspond")

    mat<-matrix(rep(1,100)+1e6,ncol=10);mat[,2]<-1e5;colnames(mat)<-letters[1:10];rownames(mat)<-letters[1:10]
    expect_error(FixedExpressionData("MAS5",mat )  ,"Cannot determine the targetValue that was used for MAS5.0" )
   
    mat<-matrix(rep(1,100)+1e6,ncol=10);mat[,2]<-1e5;colnames(mat)<-letters[1:10];rownames(mat)<-letters[1:10]
    expect_true(is(FixedExpressionData("MAS5",mat,targetValue=100 ) ,"FixedExpressionData"))

    mat<-matrix(rep(1,10)+1e6,ncol=1);colnames(mat)<-letters[1];rownames(mat)<-letters[1:10]
    expect_warning(FixedExpressionData("MAS5",mat,targetValue=100 ),"Using the given targetValue, but it does not correspond")

    mat<-matrix(rep(1,100),ncol=10);colnames(mat)<-letters[1:10];rownames(mat)<-letters[1:10]
    expect_true(is(FixedExpressionData("MAS5",mat,isLog2Transformed=TRUE),"FixedExpressionData"))
    
    mat<-matrix(rep(1,100)+1e6,ncol=10);colnames(mat)<-letters[1:10];rownames(mat)<-letters[1:10]
    expect_true(is(FixedExpressionData("MAS5",mat),"FixedExpressionData"))
    
}
)


test_that("getTargetValue with signature('FixedExpressionData')",{
    mat<-matrix(rep(1,100)+1e6,ncol=10);colnames(mat)<-letters[1:10];rownames(mat)<-letters[1:10]
    eset.fixed<-FixedExpressionData("MAS5",mat)
    expect_equal(getTargetValue(eset.fixed),1e6)

    expect_warning({
        mat<-matrix(rep(1,100)+1e6,ncol=10);colnames(mat)<-letters[1:10];rownames(mat)<-letters[1:10]
        eset.fixed<-FixedExpressionData("MAS5",mat,targetValue=500)
        expect_equal(getTargetValue(eset.fixed),500)
    })

})


test_that("setTargetValue with signature('FixedExpressionData')",{
    expect_equal({
        mat<-matrix(rep(1,100)+1e6,ncol=10);colnames(mat)<-letters[1:10];rownames(mat)<-letters[1:10]
        eset.fixed<-FixedExpressionData("MAS5",mat)
        setTargetValue(eset.fixed)<-100
        getTargetValue(eset.fixed)}, 100)

    expect_error({
        mat<-matrix(rep(1,100)+1e6,ncol=10);colnames(mat)<-letters[1:10];rownames(mat)<-letters[1:10]
        eset.fixed<-FixedExpressionData("GCRMA",mat)
        setTargetValue(eset.fixed)<-100
        }, "Function 'setTargetValue' does only apply to MAS5.0 normalized data")
})


test_that("getExpressionEnvironment with signature('FixedExpressionData')",{
   a <- expect_type({
        mat<-matrix(rep(1,100)+1e6,ncol=10);colnames(mat)<-letters[1:10];rownames(mat)<-letters[1:10]
        eset.fixed<-FixedExpressionData("MAS5",mat)
        getExpressionEnvironment(eset.fixed)
    }, "environment")

    
    expect_true("expressionMatrix"%in%ls(getExpressionEnvironment(eset.fixed)))
})

test_that("exprs function with signature('FixedExpressionData')",{
    a <- expect_true({
        mat<-matrix(rep(1,100)+1e6,ncol=10);colnames(mat)<-letters[1:10];rownames(mat)<-letters[1:10]
        eset.fixed<-FixedExpressionData("MAS5",mat)
        is(exprs(eset.fixed),"matrix")
    })
 
})



test_that("rawExprs function with signature('FixedExpressionData')",{
    a <- expect_true({
        mat<-matrix(rep(1,100)+1e6,ncol=10);colnames(mat)<-letters[1:10];rownames(mat)<-letters[1:10]
        eset.fixed<-FixedExpressionData("MAS5",mat)
        is(rawExprs(eset.fixed),"matrix")
    })
 
})


test_that("dim for FixedExpressionData",{
    expect_equal({
        mat<-matrix(rep(1,50)+1e6,ncol=5);colnames(mat)<-letters[1:5];rownames(mat)<-letters[1:10]
        eset.fixed<-FixedExpressionData("MAS5",mat)
        dim(eset.fixed)
    },c(10,5))
})


test_that("rownames for FixedExpressionData",{
    expect_equal({
        mat<-matrix(rep(1,50)+1e6,ncol=5);colnames(mat)<-letters[1:5];rownames(mat)<-letters[1:10]
        eset.fixed<-FixedExpressionData("MAS5",mat)
        rownames(eset.fixed)
    },letters[1:10])
})


test_that("colnames for FixedExpressionData",{
    expect_equal({
        mat<-matrix(rep(1,50)+1e6,ncol=5);colnames(mat)<-letters[1:5];rownames(mat)<-letters[1:10]
        eset.fixed<-FixedExpressionData("MAS5",mat)
        colnames(eset.fixed)
    },letters[1:5])
})



test_that("Extract Parts of an FixedExpressionData using '['",{

    mat<-matrix(seq(50)+1e6,ncol=5);colnames(mat)<-letters[1:5];rownames(mat)<-letters[1:10]
    eset.fixed<-FixedExpressionData("MAS5",mat,targetValue=100)
    expect_equal(exprs(eset.fixed[2:3,3:5]),mat[2:3,3:5])
    expect_equal(exprs(eset.fixed[2:3,]),mat[2:3,])
    expect_equal(exprs(eset.fixed[,3:4]),mat[,3:4])
    expect_equal(exprs(eset.fixed[2,3]),mat[2,3,drop=FALSE])

})


test_that("Extract Parts of an FixedExpressionData using '[['",{
    mat<-matrix(seq(50)+1e6,ncol=5);colnames(mat)<-letters[1:5];rownames(mat)<-letters[1:10]
    eset.fixed<-FixedExpressionData("MAS5",mat,targetValue=100)
    expect_equal(exprs(eset.fixed[[2:3,3:5]]),mat[2:3,3:5])
    expect_equal(exprs(eset.fixed[[2:3,]]),mat[2:3,])
    expect_equal(exprs(eset.fixed[[,3:4]]),mat[,3:4])
    expect_equal(exprs(eset.fixed[[2,3]]),mat[2,3,drop=FALSE])

})



test_that("Test explicitlyChangeExprs on a FixedExpressionData",{
    mat<-matrix(seq(50)+1e6,ncol=5);colnames(mat)<-letters[1:5];rownames(mat)<-letters[1:10]
    eset.fixed<-FixedExpressionData("MAS5",mat,targetValue=100)
    mat.new<-matrix(1,ncol=1);colnames(mat.new)<-"C";rownames(mat.new)<-"D"
    expect_equal({
        explicitlyChangeExprs(eset.fixed)<-mat.new
        exprs(eset.fixed)
    },mat.new)

    mat.new<-matrix(seq(50)+1e5,ncol=5);colnames(mat.new)<-letters[1:5];rownames(mat.new)<-letters[1:10]
        
    expect_equal({
        explicitlyChangeExprs(eset.fixed)<-mat.new
        exprs(eset.fixed)
    },mat.new)

})
 

##All elements in .classifierHookList are of type ClassifierParameters?
test_that("returns ClassifierParameters Object",{
    isClassifierParametersObject<-lapply(.classifierHookList,function(x){
        inherits(x(FALSE),"ClassifierParameters")
    })

    allOK<-all(unlist(isClassifierParametersObject))
    expect_true(allOK)
})


#** Test info retrieval
test_that("classifierHookList Info",{
    structureOK<-all(unlist(lapply(geneClassifiers:::.classifierHookList,function(x){all(names(x())==c("name","normalizationMethod","description"))})))
    expect_equal(structureOK , TRUE)
})

test_that("functionDefs for hook",{
    #Test: classifierHooks have the correct function defintion
     funcDefCorrect<-unlist(lapply(.classifierHookList,function(x){
        fml<-formals(x)
        return(all(names(fml)==c("infoOnly","...")) & all(unlist(fml)==c(TRUE,"")))
    }))
    allOK<-all(funcDefCorrect)
    expect_true(allOK)
})


test_that("classifierHookList argumentReturnOrder",{
    registeredClassifiers<-lapply(.classifierHookList,function(x){x()})
    argumentReturnOrder<-unlist(lapply(registeredClassifiers,function(x){
        all(names(x)==c("name","normalizationMethod","description"))
    }))
    allOK<-all(argumentReturnOrder)
    expect_true(allOK)
})

test_that("classifierHookList namesCorrect",{
    registeredClassifiers<-lapply(.classifierHookList,function(x){x()})
    namesCorrect<-unlist(lapply(registeredClassifiers,function(x){
        is.character(x["name"]) & nchar(x["name"])>2
    }))
    allOK<-all(namesCorrect)
    expect_true(allOK)
})

test_that("classifierHookList normalizationMethodCorrect",{
    registeredClassifiers<-lapply(.classifierHookList,function(x){x()})
    normalizationMethodCorrect<-unlist(lapply(registeredClassifiers,function(x){
        x["normalizationMethod"]%in%getNormalizationMethods()
    }))
    allOK<-all(normalizationMethodCorrect)
    expect_true(allOK)
})

test_that("classifierHookList namesDuplicated",{
    registeredClassifiers<-lapply(.classifierHookList,function(x){x()})
    namesDuplicated<-duplicated(unlist(lapply(registeredClassifiers,function(x){
        x["name"]
    })))
    allOK<-!any(namesDuplicated)
    expect_true(allOK)
})

allowedKeyWords<-c("targetValue","truncate","to.log","allow.reweighted","to.meancentering","to.unitvariance","to.referencemeanvar")
##Loop through all classifiers
lapply(.classifierHookList,function(x){
    classifier<-x(FALSE)
    nm<-getNormalizationMethod(classifier)
    
    ec<-getEventChain(classifier)
    probeNames<-getProbeNames(classifier)
    
    #$ 'only allowed keywords in eventchain?
    testdescription<-paste("Eventchain keywords for",getName(classifier))
    test_that(testdescription,{
        correctEchainKeywords<-all(names(ec)%in%allowedKeyWords)
        expect_true(correctEchainKeywords)
    }) 


    #$ 'trainingData available?
    if (hasTrainingData(classifier)) {
        testdescription<-paste("is trainingData available for",getName(classifier))
        test_that(testdescription,{
            trainingData<-try(getTrainingData(classifier),silent=TRUE)
            expect_true(!inherits(trainingData,"try_error"))
        })
    }

    
    #$ 'probeNames given?
    testdescription<-paste("Probenames given for",getName(classifier))
    test_that(testdescription,expect_true(!is.null(probeNames) & all(!is.na(probeNames))))

    #$ 'weights given?
    testdescription<-paste("Weights given for",getName(classifier))
    test_that(testdescription,expect_true(!is.null(getWeights(classifier)) & all(!is.na(getWeights(classifier)))))

    #$ 'targetValue' (Must be given for MAS5.0 classifiers only. Only used for mas5 classifiers. Indicating the required targetValue)
    if (nm == "MAS5.0") {
        testdescription<-paste("Eventchain structure error: keyword 'targetValue' must be given for a mas5 classifier (",getName(classifier),")")
        test_that(testdescription, expect_true("targetValue"%in%names(ec)))

        testdescription<-paste("Eventchain structure error: keyword 'targetValue' must have a numeric value. (",getName(classifier),")")
        test_that(testdescription, expect_true(is.numeric(ec[["targetValue"]])))

        testdescription<-paste("Eventchain structure error: keyvalue 'targetValue' must be a positive real number. (",getName(classifier),")")
        test_that(testdescription, expect_true(ec[["targetValue"]]>=1))

    } else { ##Not MAS5.0
        testdescription<-paste("Targetvalue given for non MAS5.0. (",getName(classifier),")")
        test_that(testdescription, expect_true(!"targetValue"%in%names(ec))) 
    }

  
    #$ 'truncate' (Must be given. Truncates values below a given value (applies to untransformed/unlogged data.)
    testdescription<-paste("Eventchain structure error: keyword 'truncate' must be given as numeric value. (",getName(classifier),")")
    test_that(testdescription, expect_true("truncate"%in%names(ec) & is.numeric(ec[["truncate"]])))

    #$ 'to.log' (Although probably only logical to apply in MAS5.0 normalized data, always applicable)
    if (!is.null(ec[["to.log"]])){
        testdescription<-paste("Eventchain structure error: keyword 'to.log' must be a numerical value representing the base number for the log. (",getName(classifier),")")
        test_that(testdescription, expect_true(is.numeric(ec[["to.log"]])))
    }

    #$ 'allow.reweighted' Must be given (should reweigting be allowed in case of missing probe-set(s)?)
    testdescription<-paste("Eventchain structure error: keyword 'allow.reweighted' must be a logical TRUE or FALSE. (",getName(classifier),")")
    test_that(testdescription, expect_true("allow.reweighted"%in%names(ec) & is.logical(ec[["allow.reweighted"]])))


    #$ 'to.meancentering' (per probe-set based centering to mean=0)
    if ("to.meancentering"%in%names(ec)){ 
        testdescription<-paste("Eventchain structure error: keyword 'to.meancentering' must be a logical TRUE or FALSE. (",getName(classifier),")")
        test_that(testdescription, expect_true(is.logical(ec[["to.meancentering"]])))
        ##Note that under normal circumstances (i.e. batch correction) refrence means are not used thus not required!
    }

    #$ 'to.unitvariance' (per probe-set based scaling to sd=1)
    if ("to.unitvariance"%in%names(ec)){
        testdescription<-paste("Eventchain structure error: keyword 'to.unitvariance' must be a logical TRUE or FALSE. (",getName(classifier),")")
        test_that(testdescription, expect_true(is.logical(ec[["to.unitvariance"]])))
        ##Note that under normal circumstances (i.e. batch correction) refrence sds are not used thus not required!
    }

    #$ 'to.referencemeanvar' (set probe-set means and variances to equal values as observed in training set)
    if ("to.referencemeanvar"%in%names(ec)){
         testdescription<-paste("Eventchain structure error: keyword 'to.referencemeanvar' must be a logical TRUE or FALSE. (",getName(classifier),")")
        test_that(testdescription, expect_true(is.logical(ec[["to.referencemeanvar"]])))
        
        if (length(probeNames)>0) {
            if (ec[["to.referencemeanvar"]]==TRUE) {
                testdescription<-paste("Eventchain structure error: means and sds must be given when keyword 'to.referencemeanvar' == TRUE. (",getName(classifier),")")
                test_that(testdescription, expect_true(length(getMeans(classifier))>0 & length(getMeans(classifier))==length(probeNames) & length(getSds(classifier))==length(probeNames)))
            }
        }
    }


    #$ 'allow.reweighted' = TRUE (only sensical if trainingset is given)
    if ("allow.reweighted"%in%names(ec)){
        testdescription<-paste("Eventchain structure error: keyword 'allow.reweighted' must be a logical TRUE or FALSE. (",getName(classifier),")")
        test_that(testdescription, expect_true(is.logical(ec[["allow.reweighted"]])))     
        
        if (ec[["allow.reweighted"]]==TRUE) {
                testdescription<-paste("Eventchain error: 'allow.reweighted'=TRUE only meaningful if trainingData given. (",getName(classifier),")")
                test_that(testdescription, expect_true(hasTrainingData(classifier)))
        }
    }


    testdescription<-paste("Check normalization method for",getName(classifier))
    test_that(testdescription,{
        correctNormalizationMethod<-nm%in%getNormalizationMethods()
        expect_true(correctNormalizationMethod)
    })     
    
    
    if (hasTrainingData(classifier)){
        trainingData<-getTrainingData(classifier)
        intersection<-intersect(rownames(trainingData),probeNames)
        testdescription <- paste("trainings dataset contain more (or less) probes than probeNames for classifier ",getName(classifier),".")
        test_that(testdescription,expect_true(length(intersection)==nrow(trainingData) & length(intersection)==length(probeNames)))

        testdescription<-paste("Check normalization method training data for",getName(classifier))
        preprocData<-preproc(experimentData(trainingData))
        trainDatNormMethod <- preprocData[["normalisationMethod"]]

        test_that(testdescription,{
            isOK<-FALSE;
            if (!is.null(trainDatNormMethod)) {
                isOK<-trainDatNormMethod%in%getNormalizationMethods() & trainDatNormMethod==nm
                if (nm=="MAS5.0"){ 
                    isOK<- isOK & !is.null(preprocData[["targetValue"]]) ##Provide a target value in case of MAS5.0
            
                }
            }
            expect_true(isOK)
        })
         
    }
})
 

#' @importFrom utils packageVersion packageName
packageVersionInternal <- function() {
    ## To handle a roxygen run
    packageName = packageName()
    if (packageName == "roxygen_devtest") {
        return(package_version("0.0.0"))
    }
    packageVersion(packageName())
}

setGeneric("FixedExpressionData", function(normalizationMethod, expressionMatrix, 
    ...) {
    standardGeneric("FixedExpressionData")
})

setGeneric("ClassifierResults", function(weightingType, batchCorrection, score, classifierParameters) {
    standardGeneric("ClassifierResults")
})

setGeneric("ClassifierParameters", function(name, doRun, hasTrainingData, normalizationMethod, 
    weights, description = "", intercept = NULL, means = NULL, sds = NULL, decisionBoundaries = NULL, 
    eventChain = NULL, citations = NULL) {
    standardGeneric("ClassifierParameters")
})

setGeneric("TransformationProcess", function(name, values, ...) {
    standardGeneric("TransformationProcess")
})

############################################################## 
#' Obtain classifier score.
#'
#' \code{getScores} returns the resulting scores from a classifier
#' run
#'
#' @param object An object of class \code{\link{ClassifierResults}}
#'
#' @return A numeric vector with scores per sample
#'
#' @family classifier results
#'
#' @export
#' @docType methods
#' @rdname getScores-methods
#'
#' @examples
#' data(exampleMAS5)
#' myData <- setNormalizationMethod(exampleMAS5, 'MAS5.0', targetValue=500)
#' results <- runClassifier('EMC92', myData)
#' getScores( results )
#' getClassifications( results )
setGeneric("getScores", function(object) {
    standardGeneric("getScores")
})

############################################################## 
#' Obtain classifier classifications.
#'
#' \code{getClassifications} returns the resulting classifications.
#'
#' @param object An object of class \code{\link{ClassifierResults}}
#'
#' @return A vector of orderd factors with classifications per sample
#'
#' @family classifier results
#'
#' @export
#' @docType methods
#' @rdname getClassifications-methods
#'
#' @examples
#' myData <- setNormalizationMethod(exampleMAS5, 'MAS5.0',targetValue=500)
#' results <- runClassifier('EMC92', myData)
#' getScores( results )
#' getClassifications( results )
setGeneric("getClassifications", function(object) {
    standardGeneric("getClassifications")
})

setGeneric("runProcess", function(object, expressionMat) {
    standardGeneric("runProcess")
})

setGeneric("getValues", function(object) {
    standardGeneric("getValues")
})



############################################################## 
#' Obtain the batch correction status for a classifier result.
#'
#' \code{getBatchCorrection} returns TRUE or FALSE
#'  indicating whether correction was applied
#'
#' @param object An object of class \code{\link{ClassifierResults}}
#' as returned by \code{\link{runClassifier}}
#'
#' @return TRUE or FALSE
#'
#' @family classifier results
#'
#' @export
#' @docType methods
#' @rdname getBatchCorrection-methods
#'
#' @examples
#' myData <- setNormalizationMethod(exampleMAS5, 'MAS5.0',targetValue=500)
#' results <- runClassifier('EMC92', myData)
#' getBatchCorrection( results )
setGeneric("getBatchCorrection", function(object) {
    standardGeneric("getBatchCorrection")
})

############################################################## 
#' Obtain the weighting type used to obtain a classifier result.
#'
#' \code{getWeightingType} returns weigthing type 
#' 
#'
#' @param object An object of class \code{\link{ClassifierResults}}
#' as returned by \code{\link{runClassifier}}
#'
#' @return one of the values in \code{getWeightingTypes()}
#'
#' @family classifier results
#'
#' @export
#' @docType methods
#' @rdname getWeightingType-methods
#'
#' @examples
#' myData <- setNormalizationMethod(exampleMAS5, 'MAS5.0',targetValue=500)
#' results <- runClassifier('EMC92', myData)
#' getWeightingType( results )

setGeneric("getWeightingType", function(object) {
    standardGeneric("getWeightingType")
})



############################################################## 
#' Obtain object names.
#'
#' \code{getName} returns the name associated with the requested object.
#'
#' @param object The object to get the name of.
#'
#' @return The return value is a character string
#'
#' @seealso \code{\link{ClassifierParameters}}
#' @seealso \code{\link{ClassifierResults}}
#'
#' @export
#' @docType methods
#' @rdname getName-methods
#'
#' @examples
#' aClassifier <- getClassifier('EMC92')
#' getName( aClassifier )
setGeneric("getName", function(object) {
    standardGeneric("getName")
})

setGeneric("explicitlyChangeExprs<-", function(object, value) {
    standardGeneric("explicitlyChangeExprs<-")
})

setGeneric("getExpressionEnvironment", function(object, value) {
    standardGeneric("getExpressionEnvironment")
})

############################################################## 
#' Obtain normalization method
#'
#' The function \code{getNormalizationMethod} returns the normalization method
#' associated with the object
#'
#' @param object An object of class \code{\link{FixedExpressionData}} or
#' \code{\link{ClassifierParameters}}
#'
#' @return A character string indicating the normalization method.
#'
#' @seealso \code{\link{getNormalizationMethods}}
#' @family classifier information functions
#' @family fixed data information extraction functions
#'
#' @export
#' @docType methods
#' @rdname getNormalizationMethod-methods
#'
#' @examples
#' data(exampleMAS5)
#' myData <- setNormalizationMethod(exampleMAS5, 'MAS5.0', targetValue=500)
#' aClassifier <- getClassifier('EMC92')
#' getNormalizationMethod( myData )
#' getNormalizationMethod( aClassifier )
setGeneric("getNormalizationMethod", function(object) {
    standardGeneric("getNormalizationMethod")
})

############################################################## 
#' Obtain the targetValue
#'
#' \code{getTargetValue} returns the current applied targetValue
#' in the MAS5.0 gene expression data.
#'
#' @param object An object of class \code{\link{FixedExpressionData}}
#'
#' @return A numeric value
#'
#' @family fixed data information extraction functions
#'
#' @export
#' @docType methods
#' @rdname getTargetValue-methods
#'
#' @examples
#' data(exampleMAS5)
#' myData <- setNormalizationMethod(exampleMAS5, 'MAS5.0', targetValue=500)
#' getTargetValue( myData )
setGeneric("getTargetValue", function(object) {
    standardGeneric("getTargetValue")
})

setGeneric("setTargetValue<-", function(object, value) {
    standardGeneric("setTargetValue<-")
})

setGeneric("rawExprs", function(object) {
    standardGeneric("rawExprs")
})

setGeneric("addTransformationProcess", function(object, name, values, ...) {
    standardGeneric("addTransformationProcess")
})

setGeneric("getTransformationProcesses", function(object) {
    standardGeneric("getTransformationProcesses")
})

setGeneric("removeTransformationProcesses", function(object, n) {
    standardGeneric("removeTransformationProcesses")
})

setGeneric("getNormalizationParameters", function(object) {
    standardGeneric("getNormalizationParameters")
})

############################################################## 
#' Obtain a classifier definition.
#'
#' \code{getClassifier} returns a requested classifier definition.
#'
#' @param value Either a text value indicating a classifier name
#' (see \code{\link{showClassifierList}}), or an object of
#' class \code{\link{ClassifierResults}} as returned by the
#' \code{\link{runClassifier}} function.
#'
#' @return The return value is a classifier definition which
#' is encoded in an object of class \code{\link{ClassifierParameters}}.
#' This can be used as input argument for the \code{\link{runClassifier}}
#' function.
#'
#' @family classifier information functions
#' @seealso \code{\link{ClassifierParameters}} and \code{\link{runClassifier}}
#'
#' @export
#' @docType methods
#' @rdname getClassifier-methods
#'
#' @examples
#' getClassifier('EMC92')
setGeneric("getClassifier", function(value) {
    standardGeneric("getClassifier")
})

############################################################## 
#' Obtain probe-set names.
#'
#' \code{getProbeNames} returns the probe names associated with
#' the requested classifier.
#'
#' @param object An object of class \code{\link{ClassifierParameters}}
#' as returned by \code{\link{getClassifier}}
#'
#' @return The return value is a character vector of probe-set names.
#'
#' @family classifier information functions
#' @seealso \code{\link{ClassifierParameters}}
#'
#' @export
#' @docType methods
#' @rdname getProbeNames-methods
#'
#' @examples
#' aClassifier <- getClassifier('EMC92')
#' getProbeNames( aClassifier )
setGeneric("getProbeNames", function(object) {
    standardGeneric("getProbeNames")
})

############################################################## 
#' Obtain classifier weights.
#'
#' \code{getWeights} returns the probe weights associated with
#' the classifier.
#'
#' @param object An object of class \code{\link{ClassifierParameters}}
#' as returned by \code{\link{getClassifier}}
#'
#' @return A numeric vector.
#'
#' @family classifier information functions
#'
#' @export
#' @docType methods
#' @rdname getWeights-methods
#'
#' @examples
#' aClassifier <- getClassifier('EMC92')
#' getWeights(aClassifier)
setGeneric("getWeights", function(object) {
    standardGeneric("getWeights")
})

############################################################## 
#' Obtain classifier training data.
#'
#' \code{getTrainingData} returns the training data that was used
#' for building the classifier.
#'
#' @param object An object of class \code{\link{ClassifierParameters}}
#' as returned by \code{\link{getClassifier}}
#'
#' @return An object of class \code{\link{ExpressionSet}}
#'
#' @family classifier information functions
#'
#' @export
#' @docType methods
#' @rdname getTrainingData-methods
#'
#' @examples
#' aClassifier <- getClassifier('EMC92')
#' getTrainingData(aClassifier)
setGeneric("getTrainingData", function(object) {
    standardGeneric("getTrainingData")
})

############################################################## 
#' Obtain citations to the classifier
#'
#' \code{getCitations} Obtain citations to the classifier
#'
#' @param object An object of class \code{\link{ClassifierParameters}}
#' as returned by \code{\link{getClassifier}}
#'
#' @return A character vector
#'
#' @family classifier information functions
#'
#' @export
#' @docType methods
#' @rdname getCitations-methods
#'
#' @examples
#' aClassifier <- getClassifier('EMC92')
#' getCitations(aClassifier)
setGeneric("getCitations", function(object) {
    standardGeneric("getCitations")
})


############################################################## 
#' Obtain the decision boundaries defined for the classifier.
#'
#' \code{getDecisionBoundaries} returns the a numeric vector
#'  of boundary values that separate the risk groups.
#'
#' @param object An object of class \code{\link{ClassifierParameters}}
#' as returned by \code{\link{getClassifier}}
#'
#' @return A numeric vector
#'
#' @family classifier information functions
#'
#' @export
#' @docType methods
#' @rdname getDecisionBoundaries-methods
#'
#' @examples
#' aClassifier <- getClassifier('EMC92')
#' getDecisionBoundaries(aClassifier)
setGeneric("getDecisionBoundaries", function(object) {
    standardGeneric("getDecisionBoundaries")
})


############################################################## 
#' Obtain classifiers' intercept.
#'
#' \code{getIntercept} returns the numeric value of the
#' classifier's intercept.
#'
#' @param object An object of class \code{\link{ClassifierParameters}}
#' as returned by \code{\link{getClassifier}}
#'
#' @return A numeric value
#'
#' @family classifier information functions
#'
#' @export
#' @docType methods
#' @rdname getIntercept-methods
#'
#' @examples
#' aClassifier <- getClassifier('EMC92')
#' getIntercept(aClassifier)
setGeneric("getIntercept", function(object) {
    standardGeneric("getIntercept")
})

############################################################## 
#' Obtain classifiers' description.
#'
#' \code{getDescription} returns the descriptive text associated
#' with the classifier.
#'
#' @param object An object of class \code{\link{ClassifierParameters}}
#' as returned by \code{\link{getClassifier}}
#'
#' @return A character string describing the classifier
#'
#' @family classifier information functions
#'
#' @export
#' @docType methods
#' @rdname getDescription-methods
#'
#' @examples
#' aClassifier <- getClassifier('EMC92')
#' getDescription(aClassifier)
setGeneric("getDescription", function(object) {
    standardGeneric("getDescription")
})

############################################################## 
#' Perform classification.
#'
#' \code{runClassifier} performs classification by applying a
#' classifier to gene expression data.
#'
#' @param classifierParameters Either a text value indicating a
#' classifier name (see \code{\link{showClassifierList}}), or an
#' object of class \link{ClassifierParameters} as returned by the
#' \code{\link{getClassifier}} function.
#'
#' @param fixedExpressionData The data to be classified in the
#' form of a \code{\link{FixedExpressionData}} object as returned
#' by the \code{\link{setNormalizationMethod}} function.
#'
#' @param ... see details
#'
#' @return The classification results as an object of class
#' \code{\link{ClassifierResults}}.
#'
#' @details A list of possible classifiers is obtained by
#' \code{\link{showClassifierList}}. The data to be classified
#' is first to be processed by the \link{setNormalizationMethod}
#' function. By default the data is assumed to contain many (n>=25)
#' samples with corresponding probe-sets needed for classification.
#' If one of these conditions is not met, a classifier outcome might
#' be seriously affected. By default an error is given. Although
#' strongly discouraged, it is possible to circumvent the security
#' checks. If not all required probe-sets are included in the input
#' set, you can explicitly pass the parameter \code{allow.reweighted = TRUE}
#' to the \code{runClassifier} function in order to determine the
#' classifier outcome using less probe-sets (e.g. possible if the
#' missing probe-sets are known to have minimal contribution).See
#' \code{vignette('MissingCovariates')} for more information. If
#' the input data has a small number of samples, the default batch
#' correction becomes ineffective. If you are aware of the possible
#' negative effects you can force to not use batch correction by
#' passing the parameter \code{do.batchcorrection=FALSE}.
#'
#' @family workflow functions
#'
#' @export
#' @docType methods
#' @rdname runClassifier-methods
#'
#' @examples
#' data(exampleMAS5)
#' myData<-setNormalizationMethod(exampleMAS5,'MAS5.0',targetValue=500)
#' runClassifier('EMC92',myData)
setGeneric("runClassifier", function(classifierParameters, fixedExpressionData, ...) {
    standardGeneric("runClassifier")
})

############################################################## 
#' Obtain classifiers' reference means.
#'
#' \code{getMeans} returns the reference means encoded in the
#' in the classifier. 
#'
#' @param object An object of class \code{\link{ClassifierParameters}}
#' as returned by \code{\link{getClassifier}}
#'
#' @return Returns a numeric vector of probe set means as observed
#' in the reference data
#'
#'
#' @family classifier information functions
#' @seealso showClassifierList getClassifier runClassifier
#'
#' @export
#' @docType methods
#' @rdname getMeans-methods
#'
#' @examples
#' aClassifier <- getClassifier('EMC92')
#' getMeans(aClassifier)
setGeneric("getMeans", function(object) {
    standardGeneric("getMeans")
})

############################################################## 
#' Obtain classifiers' reference standard deviations.
#'
#' \code{getSds} returns the reference standard deviations
#'  encoded in the classifier. 
#'
#' @param object An object of class \code{\link{ClassifierParameters}}
#' as returned by \code{\link{getClassifier}}
#'
#' @return Returns a numeric vector of probe set standard deviations 
#' as observed in the reference data
#'
#'
#' @family classifier information functions
#' @seealso showClassifierList getClassifier runClassifier
#'
#' @export
#' @docType methods
#' @rdname getSds-methods
#'
#' @examples
#' aClassifier <- getClassifier('EMC92')
#' getSds(aClassifier)
setGeneric("getSds", function(object) {
    standardGeneric("getSds")
})

setGeneric("getDoRun", function(object) {
    standardGeneric("getDoRun")
})

############################################################## 
#' Obtain classifiers' event chain.
#'
#' \code{getEventChain} returns the event chain encoded in the
#' in the classifier. The eventchain indicates what preprocessing
#' steps are performed by the \code{\link{runClassifier}} function
#' prior to classification.
#'
#' @param object An object of class \code{\link{ClassifierParameters}}
#' as returned by \code{\link{getClassifier}}
#'
#' @return Returns the event chain encoded in the
#' in the classifier encoded as a named list.
#'
#'
#' @family classifier information functions
#' @seealso showClassifierList getClassifier runClassifier
#'
#' @export
#' @docType methods
#' @rdname getEventChain-methods
#'
#' @examples
#' aClassifier <- getClassifier('EMC92')
#' getEventChain(aClassifier)
setGeneric("getEventChain", function(object) {
    standardGeneric("getEventChain")
})

setGeneric("reWeightClassifier", function(object, fixedExpressionData) {
    standardGeneric("reWeightClassifier")
})

setGeneric("hasTrainingData", function(object) {
    standardGeneric("hasTrainingData")
})

#' @details
#' Combining gene expression profiling data with survival data has led to the 
#' development of robust outcome predictors (gene classifiers).This package 
#' provides a method for running gene classifiers generating patient specific 
#' predictive outcomes. This package is intended to support and enable 
#' research. To yield stable results, this package requires a dataset of
#' at least 20 patients.
#'
#' For detail on how to use this package see the vignette: 
#' \code{vignette('geneClassifiers')}
#'
#' @references
#' Kuiper R, Broyl A, de Knegt YA, Van Vliet MH, Van Beers EH, van der Holt B, el Jarari L, Mulligan G, Gregory W, Morgan G, Goldschmidt H. A gene expression signature for high-risk multiple myeloma. Leukemia. 2012 Nov;26(11):2406.
#' @keywords internal
"_PACKAGE"
# > [1] '_PACKAGE'

setOldClass("package_version")

#' @name ClassifierParameters
#' @title An S4 class to store classifier parameters.
#'
#'
#' @description  This class stores classifier related information
#' This is information on probe-sets used and their weightings,
#' means, standard deviations and covariance structure as observed in
#' the classifiers training data, and the description of the procedure
#' on how to preprocess new data prior to application of the classifier.
#'
#' @slot name A character string indicating the name of the classifier
#' @slot description A short description of the classifier
#' @slot citations A character vector of citations to literature
#' @slot normalizationMethod A character string indicating the normalization
#' method to apply
#' @slot eventChain A list of preprocessing steps

#' @slot probeNames A character vector
#' @slot intercept A numeric value
#' @slot weights A numeric vector
#' @slot decisionBoundaries A numeric vector with values that separate
#' the risk-groups

#' @slot doRun A function which is called for the actual classification

#' @slot means A numeric vector of probe-set means as observed in the
#' trainingsset (if available)
#' @slot sds A numeric vector of probe-set standard deviations as observed
#' in the trainingsset (if available)

#' @slot .geneClassifierVersion An object of class \code{\link{package_version}}
setClass("ClassifierParameters", representation = representation(citations = "vector", 
    name = "character", description = "character", normalizationMethod = "character", 
    probeNames = "character", weights = "numeric", intercept = "numeric", means = "numeric", 
    sds = "numeric", decisionBoundaries = "numeric", doRun = "function", eventChain = "list", 
    hasTrainingData = "logical", .geneClassifierVersion = "package_version"), prototype = list(.geneClassifierVersion = packageVersionInternal()))

setValidity("ClassifierParameters", function(object) {
    errTxt <- vector()
    if (length(getName(object)) != 1) {
        errTxt <- c(errTxt, "Classifier name must be given as a single character string")
    }
    if (length(getNormalizationMethod(object)) != 1) {
        errTxt <- c(errTxt, "Normalization method must be given as a single character string")
    } else if (!getNormalizationMethod(object) %in% getNormalizationMethods()) {
        errTxt <- c(errTxt, "Unknown normalization method")
    }
    if (length(getDescription(object)) != 1) {
        errTxt <- c(errTxt, "Classifier description must be given as a single character string")
    }
    if (length(getProbeNames(object)) == 0) {
        errTxt <- c(errTxt, "Classifier probe names must be given.")
    }
    if (length(getWeights(object)) != length(getProbeNames(object))) {
        errTxt <- c(errTxt, "Classifier weights and probe names are of different length.")
    }
    if (length(hasTrainingData(object)) != 1) {
        errTxt <- c(errTxt, "Classifier hasTrainingData indication must be either TRUE of FALSE.")
    }
    ## Do not check eventchain and dorun here. They were already part of the unit
    ## tests
    if (length(errTxt) > 0) {
        return(c(getName(object), errTxt))
    }
    return(TRUE)
})

#' @importMethodsFrom Biobase preproc experimentData
#' @importFrom utils packageVersion packageName data
setMethod("ClassifierParameters", definition = function(name, doRun, hasTrainingData, 
    normalizationMethod, weights, description = "", intercept = numeric(0), means = numeric(0), 
    sds = numeric(0), decisionBoundaries = numeric(0), eventChain = list(), citations = character(0)) {
    
    new("ClassifierParameters", name = name, normalizationMethod = normalizationMethod, 
        description = description, citations = citations, probeNames = names(weights), 
        intercept = intercept, weights = weights, means = means, sds = sds, decisionBoundaries = decisionBoundaries, 
        doRun = doRun, eventChain = eventChain, hasTrainingData = hasTrainingData)
})

setMethod("show", signature = signature(object = "ClassifierParameters"), definition = function(object) {
    cat("______________\n")
    cat("Classifier: ", getName(object), "\n")
    cat("Description: ", getDescription(object), "\n")
    cat("Based on n = ", length(getProbeNames(object)), " probe sets\n")
    boundaries <- getDecisionBoundaries
    if (length(boundaries) == 0) {
        cat("Number of risk groups: none (only continuous risk score)")
    } else if (length(boundaries) > 0) {
        cat("Number of risk groups: n = ", length(boundaries) + 1, "\n")
    }
    cat("To be used on ", getNormalizationMethod(object), " normalized data\n")
    allCitations <- paste(unlist(getCitations(object)), collapse = "; ")
    regExPattern <- paste("(?<=.{", options("width"), "})", sep = "")
    cat(strsplit(allCitations, regExPattern, perl = TRUE)[[1]], sep = "\n")
})


setMethod("hasTrainingData", signature = signature(object = "ClassifierParameters"), 
    definition = function(object) {
        return(object@hasTrainingData)
    })


#' @rdname getEventChain-methods
#' @aliases getEventChain,ClassifierParameters-method
#' @export
setMethod("getEventChain", signature = signature(object = "ClassifierParameters"), 
    definition = function(object) {
        return(object@eventChain)
    })

#' @rdname getDescription-methods
#' @aliases getDescription,ClassifierParameters-method
#' @export
setMethod("getDescription", signature = signature(object = "ClassifierParameters"), 
    definition = function(object) {
        return(object@description)
    })


#' @rdname getNormalizationMethod-methods
#' @aliases getNormalizationMethod,ClassifierParameters-method
#' @export
setMethod("getNormalizationMethod", signature = signature(object = "ClassifierParameters"), 
    definition = function(object) {
        return(object@normalizationMethod)
    })

#' @rdname getDecisionBoundaries-methods
#' @aliases getDecisionBoundaries,ClassifierParameters-method
#' @export
setMethod("getDecisionBoundaries", signature = signature(object = "ClassifierParameters"), 
    definition = function(object) {
        return(object@decisionBoundaries)
    })

#' @rdname getIntercept-methods
#' @aliases getIntercept,ClassifierParameters-method
#' @export
setMethod("getIntercept", signature = signature(object = "ClassifierParameters"), 
    definition = function(object) {
        return(object@intercept)
    })

#' @rdname getTrainingData-methods
#' @aliases getTrainingData,ClassifierParameters-method
#' @export
setMethod("getTrainingData", signature = signature(object = "ClassifierParameters"), 
    definition = function(object) {
        if (!hasTrainingData(object)) 
            return(NULL)
        orgClassifierName <- gsub("_reweighted", "", getName(object))
        expectedDataName <- paste(orgClassifierName, "_training", sep = "")
        trainingsData <- local({
            try(eval(parse(text = expectedDataName)), silent = TRUE)
        })
        if (!inherits(trainingsData, "ExpressionSet")) {
            stop("Could not obtain training data (", expectedDataName, ") for classifier", 
                getName(object))
        }
        return(trainingsData[getProbeNames(object), ])
    })

#' @rdname getProbeNames-methods
#' @aliases getProbeNames,ClassifierParameters-method
#' @export
setMethod("getProbeNames", signature = signature(object = "ClassifierParameters"), 
    definition = function(object) {
        return(object@probeNames)
    })

#' @rdname getWeights-methods
#' @aliases getWeights,ClassifierParameters-method
#' @export
setMethod("getWeights", signature = signature(object = "ClassifierParameters"), definition = function(object) {
    pn <- getProbeNames(object)
    w <- object@weights
    if (length(pn) == length(w)) 
        names(w) <- pn
    return(w)
})


#' @importFrom Biobase copyEnv
setMethod("reWeightClassifier", signature = signature(object = "ClassifierParameters", 
    fixedExpressionData = "FixedExpressionData"), definition = function(object, fixedExpressionData) {
    ## Function reWeightClassifier is assumed to be called by the runClassifier
    ## function which performs the required checks
    .reweight <- function(expressionSetTrain, betas, probesPresent, probesAbsent) {
        expressionSetTrain <- t(exprs(expressionSetTrain))
        mat <- cbind(1, expressionSetTrain[, c(probesPresent, probesAbsent), drop = FALSE])  #complete data
        mat0 <- cbind(1, expressionSetTrain[, probesPresent, drop = FALSE])  #known data
        mat1 <- expressionSetTrain[, probesAbsent, drop = FALSE]  #unknown data
        Omega <- solve(t(mat0) %*% mat0) %*% t(mat0) %*% mat1
        fi <- c(betas[1], betas[probesPresent]) + Omega %*% betas[probesAbsent]
        ## Assume normality to adjust new variance and bias toward the old values ensure
        ## compatability with classification thresholds
        sdNew <- sd(mat0 %*% fi)
        sdOld <- sd(mat %*% c(betas[1], betas[c(probesPresent, probesAbsent)]))
        fi[-1] <- fi[-1] * sdOld/sdNew
        orgMu <- sum(colMeans(mat) * c(betas[1], betas[c(probesPresent, probesAbsent)])) - 
            betas[1]
        newMu <- sum(colMeans(mat0) * fi) - fi[1]
        fi[1] <- betas[1] + orgMu - newMu  ##reset intercept to original value
        names(fi) <- c("Intercept", probesPresent)
        betas <- fi
        return(betas)
    }
    
    probesPresent <- getProbeNames(object)[which(getProbeNames(object) %in% rownames(fixedExpressionData))]
    probesAbsent <- getProbeNames(object)[which(!getProbeNames(object) %in% rownames(fixedExpressionData))]
    
    trainingData <- getTrainingData(object)
    
    idx <- match(probesPresent, getProbeNames(object))
    betas <- .reweight(expressionSetTrain = trainingData, betas = c(getIntercept(object), 
        getWeights(object)), probesPresent, probesAbsent)
    newIntercept <- betas[1]
    newWeights <- betas[-1, drop = FALSE]
    newObject <- ClassifierParameters(name = paste(getName(object), "_reweighted", 
        sep = ""), description = getDescription(object), normalizationMethod = getNormalizationMethod(object), 
        weights = newWeights, intercept = newIntercept, means = getMeans(object)[idx], 
        sds = getSds(object)[idx], decisionBoundaries = getDecisionBoundaries(object), 
        doRun = getDoRun(object), citations = getCitations(object), eventChain = getEventChain(object), 
        hasTrainingData = hasTrainingData(object))
    return(newObject)
})


#' @rdname getCitations-methods
#' @aliases getCitations,ClassifierParameters-method
#' @export
setMethod("getCitations", signature = signature(object = "ClassifierParameters"), 
    definition = function(object) {
        return(object@citations)
    })

#' @rdname getName-methods
#' @aliases getName,ClassifierParameters-method
#' @export
setMethod("getName", signature = signature(object = "ClassifierParameters"), definition = function(object) {
    return(object@name)
})

#' @rdname getMeans-methods
#' @aliases getMeans,ClassifierParameters-method
#' @export
setMethod("getMeans", signature = signature(object = "ClassifierParameters"), definition = function(object) {
    pn <- getProbeNames(object)
    m <- object@means
    if (length(pn) == length(m)) 
        names(m) <- pn
    return(m)
})

#' @rdname getSds-methods
#' @aliases getSds,ClassifierParameters-method
#' @export
setMethod("getSds", signature = signature(object = "ClassifierParameters"), definition = function(object) {
    pn <- getProbeNames(object)
    s <- object@sds
    if (length(pn) == length(s)) 
        names(s) <- pn
    return(s)
})


setMethod("getDoRun", signature = signature(object = "ClassifierParameters"), definition = function(object) {
    return(object@doRun)
})
#' @rdname runClassifier-methods
#' @aliases runClassifier,character,FixedExpressionData-method
#' @export
setMethod("runClassifier", signature = signature(classifierParameters = "character", 
    fixedExpressionData = "FixedExpressionData"), definition = function(classifierParameters, 
    fixedExpressionData, ...) {
    dotList <- list(...)
    classifierParameters <- getClassifier(classifierParameters)
    runClassifier(classifierParameters, fixedExpressionData, ...)
})

#' @rdname runClassifier-methods
#' @aliases runClassifier,ClassifierResults,FixedExpressionData-method
#' @export
#' @importFrom methods new
#' @importFrom stats sd
#' @importMethodsFrom Biobase exprs
setMethod("runClassifier", signature = signature(classifierParameters = "ClassifierParameters", 
    fixedExpressionData = "FixedExpressionData"), definition = function(classifierParameters, 
    fixedExpressionData, ...) {
    dotList <- list(...)
    nTP <- length(getTransformationProcesses(fixedExpressionData))
    if (nTP > 0) {
        warning("The provided data already contains transformationProcesses. Consider removing them by using the function 'removeTransformationProcesses'.")
    }
    normalizationMethodClassifier <- getNormalizationMethod(classifierParameters)
    normalizationMethodData <- getNormalizationMethod(fixedExpressionData)
    if (normalizationMethodClassifier != normalizationMethodData) {
        stop("Classifier: ", getName(classifierParameters), " can only be applied to ", 
            normalizationMethodClassifier, " normalized data. The given data is ", 
            normalizationMethodData, " nomalized.")
    }
    eventChain = getEventChain(classifierParameters)
    allow.reweighted = FALSE
    do.batchcorrection = TRUE
    if (!is.null(dotList[["allow.reweighted"]])) {
        allow.reweighted <- dotList[["allow.reweighted"]]
    }
    if (!is.null(dotList[["do.batchcorrection"]])) {
        do.batchcorrection <- dotList[["do.batchcorrection"]]
    }
    if (do.batchcorrection & ncol(fixedExpressionData) < 3) {
        stop("Only a small number of samples available (n=", ncol(fixedExpressionData), 
            "). Please consider setting 'do.batchcorrection = FALSE' but be aware this could severely induce biases!")
    }
    if (do.batchcorrection & ncol(fixedExpressionData) < 20) {
        warning("Small number of available samples (n=", ncol(fixedExpressionData), 
            "). Include more samples or consider setting 'do.batchcorrection = FALSE' but be aware this could severely induces biases!")
    }
    weightingType = "complete"
    batchCorrection = "yes"
    probesAbsent <- getProbeNames(classifierParameters)[which(!getProbeNames(classifierParameters) %in% 
        rownames(fixedExpressionData))]
    if (length(probesAbsent) > 0) {
        allowed.by.classifier = FALSE
        if (!is.null(eventChain[["allow.reweighted"]])) {
            if (eventChain[["allow.reweighted"]]) {
                ## allowed by classifier?
                allowed.by.classifier = TRUE
                if (allow.reweighted) {
                  ## Explicitly allowed by user?
                  classifierParameters <- reWeightClassifier(classifierParameters, 
                    fixedExpressionData)
                  weightingType = "reweighted"
                } else {
                  stop("Found ", length(probesAbsent), " of ", length(getProbeNames(classifierParameters)), 
                    " covariates to be missing for classifier ", getName(classifierParameters), 
                    ". Consider using 'allow.reweighted = TRUE'")
                }
            }
        }
        if (!allowed.by.classifier) {
            stop("Probe sets missing (n = ", length(probesAbsent), " of ", length(getProbeNames(classifierParameters)), 
                ") which are needed to apply classifier ", getName(classifierParameters), 
                ".  Reweighting is not allowed for this classifier.")
        }
    }
    fixedExpressionData <- fixedExpressionData[getProbeNames(classifierParameters), 
        ]  ###Filter probes
    for (eventIdx in seq_len(length(eventChain))) {
        keyword = names(eventChain[eventIdx])
        keyvalue = as.numeric(eventChain[eventIdx])
        if (keyword == "targetValue") {
            setTargetValue(fixedExpressionData) <- keyvalue
        } else if (keyword == "truncate") {
            fixedExpressionData <- addTransformationProcess(fixedExpressionData, 
                "LOWERTRUNCATE", keyvalue)
        } else if (keyword == "to.log") {
            fixedExpressionData <- addTransformationProcess(fixedExpressionData, 
                "LOG", keyvalue)
        } else if (keyword == "to.meancentering" & keyvalue > 0) {
            if (do.batchcorrection) {
                meanValues <- apply(exprs(fixedExpressionData), 1, mean, na.rm = TRUE)
            } else {
                meanValues <- getMeans(classifierParameters)
                if (length(meanValues) == 0) {
                  stop("Classifier", getName(classifierParameters), "has no reference means given and thus only batchwise approach (i.e. do.batchcorrection = TRUE) is possible.")
                }
            }
            fixedExpressionData <- addTransformationProcess(fixedExpressionData, 
                "SHIFTPERPROBE", values = -1 * meanValues)
        } else if (keyword == "to.unitvariance" & keyvalue > 0) {
            
            if (do.batchcorrection) {
                sdValues <- apply(exprs(fixedExpressionData), 1, sd)
            } else {
                sdValues <- getSds(classifierParameters)
                if (length(sdValues) == 0) {
                  stop("Classifier", getName(classifierParameters), "has no reference sd's given and thus only batchwise approach (i.e. do.batchcorrection = TRUE) is possible.")
                }
            }
            fixedExpressionData <- addTransformationProcess(fixedExpressionData, 
                "MULTIPLYPERPROBE", values = 1/sdValues)
        } else if (keyword == "to.referencemeanvar" & keyvalue > 0) {
            if (do.batchcorrection) {
                meanValues <- apply(exprs(fixedExpressionData), 1, mean, na.rm = TRUE)
                sdValues <- apply(exprs(fixedExpressionData), 1, sd, na.rm = TRUE)
                refMeanValues <- getMeans(classifierParameters)[rownames(fixedExpressionData)]
                refSdValues <- getSds(classifierParameters)[rownames(fixedExpressionData)]
                # Note that the required refmeans and refsds were already checked for in the unit
                # tests!
                fixedExpressionData <- addTransformationProcess(fixedExpressionData, 
                  "SHIFTPERPROBE", values = -meanValues)
                fixedExpressionData <- addTransformationProcess(fixedExpressionData, 
                  "MULTIPLYPERPROBE", values = refSdValues/sdValues)
                fixedExpressionData <- addTransformationProcess(fixedExpressionData, 
                  "SHIFTPERPROBE", values = refMeanValues)
            } else {
                # Do nothing
            }
        } else if (keyword == "allow.reweighted") {
        } else {
            stop("Encountered unknown keyword (", keyword, ") in the eventChain of ", 
                getName(classifierParameters))
        }
    }
    score <- getDoRun(classifierParameters)(classifierParameters, fixedExpressionData)
    classifierResults <- ClassifierResults(classifierParameters = classifierParameters, 
        score = score, batchCorrection = do.batchcorrection, weightingType = weightingType)
    return(classifierResults)
})

test_that("Checking ClassifierResults Class",{
    expect_true(is(new("ClassifierResults"),"ClassifierResults")) ##Empty unusable object    

    expect_true( is(
        new("ClassifierResults",
        score=seq_len(10)/5,
        classifierParameters=getClassifier("EMC92"),
        batchCorrection=TRUE,
        weightingType='complete'
        ),"ClassifierResults")) 
    expect_error(
        new("ClassifierResults",
        score=seq_len(10)/5,
        classifierParameters=getClassifier("EMC92"),
        batchCorrection=TRUE,
        weightingType='WrOnG ValUe'
        ),"invalid class") #

    # auto recursive testing classes
    tmpParams<-getClassifier("EMC92")
    tmpParams@name<-c("A","B")
    expect_error(
        new("ClassifierResults",
            score=seq_len(10)/5,
            classifierParameters=tmpParams,
            batchCorrection=TRUE,
            weightingType='complete'
        ),
        "invalid class"
    )
   

    
})
 

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allGenericFunctions.R,
%   R/Class_ClassifierParameters.R
\docType{methods}
\name{runClassifier}
\alias{runClassifier}
\alias{runClassifier,character,FixedExpressionData-method}
\alias{runClassifier,ClassifierParameters,FixedExpressionData-method}
\alias{runClassifier,ClassifierResults,FixedExpressionData-method}
\title{Perform classification.}
\usage{
runClassifier(classifierParameters, fixedExpressionData, ...)


  \S4method{runClassifier}{character,FixedExpressionData}(classifierParameters,
  fixedExpressionData, ...)


  \S4method{runClassifier}{ClassifierParameters,FixedExpressionData}(classifierParameters,
  fixedExpressionData, ...)
}
\arguments{
\item{classifierParameters}{Either a text value indicating a
classifier name (see \code{\link{showClassifierList}}), or an
object of class \link{ClassifierParameters} as returned by the
\code{\link{getClassifier}} function.}

\item{fixedExpressionData}{The data to be classified in the
form of a \code{\link{FixedExpressionData}} object as returned
by the \code{\link{setNormalizationMethod}} function.}

\item{...}{see details}
}
\value{
The classification results as an object of class
\code{\link{ClassifierResults}}.
}
\description{
\code{runClassifier} performs classification by applying a
classifier to gene expression data.
}
\details{
A list of possible classifiers is obtained by
\code{\link{showClassifierList}}. The data to be classified
is first to be processed by the \link{setNormalizationMethod}
function. By default the data is assumed to contain many (n>=25)
samples with corresponding probe-sets needed for classification.
If one of these conditions is not met, a classifier outcome might
be seriously affected. By default an error is given. Although
strongly discouraged, it is possible to circumvent the security
checks. If not all required probe-sets are included in the input
set, you can explicitly pass the parameter \code{allow.reweighted = TRUE}
to the \code{runClassifier} function in order to determine the
classifier outcome using less probe-sets (e.g. possible if the
missing probe-sets are known to have minimal contribution).See
\code{vignette("MissingCovariates")} for more information. If
the input data has a small number of samples, the default batch
correction becomes ineffective. If you are aware of the possible
negative effects you can force to not use batch correction by
passing the parameter \code{do.batchcorrection=FALSE}.
}
\examples{
data(exampleMAS5)
myData<-setNormalizationMethod(exampleMAS5,"MAS5.0",targetValue=500)
runClassifier("EMC92",myData)
}
\seealso{
Other workflow functions: \code{\link{getNormalizationMethod}},
  \code{\link{setNormalizationMethod}},
  \code{\link{showClassifierList}}
}
\concept{workflow functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Class_ClassifierParameters.R
\docType{class}
\name{ClassifierParameters}
\alias{ClassifierParameters}
\title{An S4 class to store classifier parameters.}
\description{
This class stores classifier related information
This is information on probe-sets used and their weightings,
means, standard deviations and covariance structure as observed in
the classifiers training data, and the description of the procedure
on how to preprocess new data prior to application of the classifier.
}
\section{Slots}{

\describe{
\item{\code{name}}{A character string indicating the name of the classifier}

\item{\code{description}}{A short description of the classifier}

\item{\code{citations}}{A character vector of citations to literature}

\item{\code{normalizationMethod}}{A character string indicating the normalization
method to apply}

\item{\code{eventChain}}{A list of preprocessing steps}

\item{\code{probeNames}}{A character vector}

\item{\code{intercept}}{A numeric value}

\item{\code{weights}}{A numeric vector}

\item{\code{decisionBoundaries}}{A numeric vector with values that separate
the risk-groups}

\item{\code{doRun}}{A function which is called for the actual classification}

\item{\code{means}}{A numeric vector of probe-set means as observed in the
trainingsset (if available)}

\item{\code{sds}}{A numeric vector of probe-set standard deviations as observed
in the trainingsset (if available)}

\item{\code{.geneClassifierVersion}}{An object of class \code{\link{package_version}}}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allGenericFunctions.R,
%   R/Class_ClassifierParameters.R
\docType{methods}
\name{getProbeNames}
\alias{getProbeNames}
\alias{getProbeNames,ClassifierParameters-method}
\title{Obtain probe-set names.}
\usage{
getProbeNames(object)

\S4method{getProbeNames}{ClassifierParameters}(object)
}
\arguments{
\item{object}{An object of class \code{\link{ClassifierParameters}}
as returned by \code{\link{getClassifier}}}
}
\value{
The return value is a character vector of probe-set names.
}
\description{
\code{getProbeNames} returns the probe names associated with
the requested classifier.
}
\examples{
aClassifier <- getClassifier("EMC92")
getProbeNames( aClassifier )
}
\seealso{
\code{\link{ClassifierParameters}}

Other classifier information functions: \code{\link{getCitations}},
  \code{\link{getClassifier}},
  \code{\link{getDecisionBoundaries}},
  \code{\link{getDescription}},
  \code{\link{getEventChain}}, \code{\link{getIntercept}},
  \code{\link{getMeans}},
  \code{\link{getNormalizationMethod}},
  \code{\link{getSds}}, \code{\link{getTrainingData}},
  \code{\link{getWeights}}
}
\concept{classifier information functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/zzz.R
\docType{methods}
\name{setNormalizationMethod}
\alias{setNormalizationMethod}
\title{Prepare data.}
\usage{
setNormalizationMethod(expressionSet, method, ...)
}
\arguments{
\item{expressionSet}{An object of class \code{\link{ExpressionSet}} containing the gene
expression data.}

\item{method}{A character string indicating the normalization that was applied to the data.
Possible values are given by \code{getNormalizationMethods()}.}

\item{...}{see details.}
}
\value{
An object of class \code{\link{FixedExpressionData}}
}
\description{
\code{setNormalizationMethod} is to be called prior to running a classifier.
}
\details{
The \code{\link{FixedExpressionData}} class forms together with the
\code{\link{ClassifierParameters}} class the basis for input to the  \code{\link{runClassifier}}
function. The data inside the \code{\link{FixedExpressionData}}-class has to be stored as it is
right after normalization.  This function may require some additional arguments:
\itemize{
\item \code{isLog2Transformed = TRUE} Use this argument if the data already underwent a
log2transformation, as is common e.g. in case of MAS5.0 normalization.
\item \code{targetValue = value} This is a MAS5.0 specific argument. It is the sample intensity
mean when the lowest and highest 2\% of intensities are discarded. If only part of the original
expression set is given to this function, then this argument is required.
}
}
\examples{
data(exampleMAS5)
myData <- setNormalizationMethod(exampleMAS5, "MAS5.0",targetValue=500)
results <- runClassifier('EMC92', myData)
getScores( results )
getClassifications( results )

}
\seealso{
Other workflow functions: \code{\link{getNormalizationMethod}},
  \code{\link{runClassifier}},
  \code{\link{showClassifierList}}
}
\concept{workflow functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/zzz.R
\docType{methods}
\name{showClassifierList}
\alias{showClassifierList}
\title{Show classifier names and descriptions.}
\usage{
showClassifierList(normalizations)
}
\arguments{
\item{normalizations}{an optional text argument of one or more normalization methods in order to filter the classifiers to be shown.}
}
\value{
A data.frame with columns: "name","normalizationMethod" and "description"
}
\description{
\code{showClassifierList} gives a data.frame of all implemented classifiers.
}
\details{
The names of the classifiers shown can be used as input for the \code{\link{runClassifier}} function and the \code{\link{getClassifier}} function.
}
\examples{
showClassifierList()
data(exampleMAS5)
myData <- setNormalizationMethod(exampleMAS5, "MAS5.0",targetValue=500)
results <- runClassifier('UAMS70', myData)
getScores( results )
getClassifications( results )

}
\seealso{
Other workflow functions: \code{\link{getNormalizationMethod}},
  \code{\link{runClassifier}},
  \code{\link{setNormalizationMethod}}
}
\concept{workflow functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Class_FixedExpressionData.R
\docType{methods}
\name{[,FixedExpressionData,ANY,ANY-method}
\alias{[,FixedExpressionData,ANY,ANY-method}
\alias{[,FixedExpressionData,ANY,missing-method}
\alias{bracket,FixedExpressionData-method}
\alias{[,FixedExpressionData,missing,ANY-method}
\alias{[[,FixedExpressionData,ANY,missing-method}
\alias{[[,FixedExpressionData,missing,ANY-method}
\alias{[[,FixedExpressionData,ANY,ANY-method}
\title{Extract}
\usage{
\S4method{[}{FixedExpressionData,ANY,ANY}(x, i, j, ..., drop = TRUE)

\S4method{[}{FixedExpressionData,ANY,missing}(x, i, j, ..., drop = TRUE)

\S4method{[}{FixedExpressionData,missing,ANY}(x, i, j, ..., drop = TRUE)

\S4method{[[}{FixedExpressionData,ANY,missing}(x, i, j, ...)

\S4method{[[}{FixedExpressionData,missing,ANY}(x, i, j, ...)

\S4method{[[}{FixedExpressionData,ANY,ANY}(x, i, j, ...)
}
\arguments{
\item{x}{An object of class \code{\link{FixedExpressionData}}}

\item{i}{the rows index}

\item{j}{the column index}

\item{...}{unused}

\item{drop}{unused}
}
\value{
An object of class \code{\link{FixedExpressionData}}
}
\description{
Extract Parts of an Object
}
\examples{
data(exampleMAS5)
myData <- setNormalizationMethod(exampleMAS5, "MAS5.0", targetValue=500)
dim(myData)
dim(myData[1:10,1:3])
dim(myData[[1:10,1:3]])
}
\seealso{
Other fixed data information extraction functions: \code{\link{dim,FixedExpressionData-method}},
  \code{\link{getNormalizationMethod}},
  \code{\link{getTargetValue}}
}
\concept{fixed data information extraction functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Class_FixedExpressionData.R
\docType{methods}
\name{dim,FixedExpressionData-method}
\alias{dim,FixedExpressionData-method}
\title{Dimensions of an Object}
\usage{
\S4method{dim}{FixedExpressionData}(x)
}
\arguments{
\item{x}{an R object, for example a matrix, array or data frame.}
}
\value{
Retrieves the 'dim attribute of the object.  It is 'NULL' or a
   vector of mode 'integer'.
}
\description{
Retrieve the dimension of an object.
}
\examples{
data(exampleMAS5)
myData <- setNormalizationMethod(exampleMAS5, "MAS5.0", targetValue=500)
dim(myData)
dim(myData[1:10,1:3])
}
\seealso{
Other fixed data information extraction functions: \code{\link{[,FixedExpressionData,ANY,ANY-method}},
  \code{\link{getNormalizationMethod}},
  \code{\link{getTargetValue}}
}
\concept{fixed data information extraction functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allGenericFunctions.R,
%   R/Class_ClassifierResults.R
\docType{methods}
\name{getBatchCorrection}
\alias{getBatchCorrection}
\alias{getBatchCorrection,ClassifierResults-method}
\title{Obtain the batch correction status for a classifier result.}
\usage{
getBatchCorrection(object)

\S4method{getBatchCorrection}{ClassifierResults}(object)
}
\arguments{
\item{object}{An object of class \code{\link{ClassifierResults}}
as returned by \code{\link{runClassifier}}}
}
\value{
TRUE or FALSE
}
\description{
\code{getBatchCorrection} returns TRUE or FALSE
 indicating whether correction was applied
}
\examples{
myData <- setNormalizationMethod(exampleMAS5, "MAS5.0",targetValue=500)
results <- runClassifier('EMC92', myData)
getBatchCorrection( results )
}
\seealso{
Other classifier results: \code{\link{getClassifications}},
  \code{\link{getScores}}, \code{\link{getWeightingType}}
}
\concept{classifier results}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allGenericFunctions.R,
%   R/Class_ClassifierParameters.R
\docType{methods}
\name{getSds}
\alias{getSds}
\alias{getSds,ClassifierParameters-method}
\title{Obtain classifiers' reference standard deviations.}
\usage{
getSds(object)

\S4method{getSds}{ClassifierParameters}(object)
}
\arguments{
\item{object}{An object of class \code{\link{ClassifierParameters}}
as returned by \code{\link{getClassifier}}}
}
\value{
Returns a numeric vector of probe set standard deviations 
as observed in the reference data
}
\description{
\code{getSds} returns the reference standard deviations
 encoded in the classifier.
}
\examples{
aClassifier <- getClassifier("EMC92")
getSds(aClassifier)
}
\seealso{
showClassifierList getClassifier runClassifier

Other classifier information functions: \code{\link{getCitations}},
  \code{\link{getClassifier}},
  \code{\link{getDecisionBoundaries}},
  \code{\link{getDescription}},
  \code{\link{getEventChain}}, \code{\link{getIntercept}},
  \code{\link{getMeans}},
  \code{\link{getNormalizationMethod}},
  \code{\link{getProbeNames}},
  \code{\link{getTrainingData}}, \code{\link{getWeights}}
}
\concept{classifier information functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Class_FixedExpressionData.R
\docType{data}
\name{exampleMAS5}
\alias{exampleMAS5}
\title{Example MAS5.0 ExpressionSet}
\format{An object of class \code{ExpressionSet} with 374 rows and 25 columns.}
\usage{
exampleMAS5
}
\description{
An \code{\link{ExpressionSet}}. The data contains a sample of gene expression 
data from patients included in the HOVON65/GMMG-HD4 trial on multiple myeloma. 
The data was MAS5.0 normalized to a target value of 500.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allGenericFunctions.R,
%   R/Class_ClassifierResults.R
\docType{methods}
\name{getWeightingType}
\alias{getWeightingType}
\alias{getWeightingTypes}
\alias{getWeightingType,ClassifierResults-method}
\title{Obtain the weighting type used to obtain a classifier result.}
\usage{
getWeightingType(object)

getWeightingTypes()

\S4method{getWeightingType}{ClassifierResults}(object)
}
\arguments{
\item{object}{An object of class \code{\link{ClassifierResults}}
as returned by \code{\link{runClassifier}}}
}
\value{
one of the values in \code{getWeightingTypes()}

either "complete" or "reweighted"
}
\description{
\code{getWeightingType} returns weigthing type

\code{getWeightingTypes} returns weigthing type
}
\examples{
myData <- setNormalizationMethod(exampleMAS5, "MAS5.0",targetValue=500)
results <- runClassifier('EMC92', myData)
getWeightingType( results )
getWeightingTypes()
}
\seealso{
Other classifier results: \code{\link{getBatchCorrection}},
  \code{\link{getClassifications}}, \code{\link{getScores}}

Other classifier results: \code{\link{getBatchCorrection}},
  \code{\link{getClassifications}}, \code{\link{getScores}}
}
\concept{classifier results}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allGenericFunctions.R,
%   R/Class_ClassifierResults.R, R/zzz.R
\docType{methods}
\name{getClassifier}
\alias{getClassifier}
\alias{getClassifier,ClassifierResults-method}
\alias{getClassifier,character-method}
\title{Obtain a classifier definition.}
\usage{
getClassifier(value)

\S4method{getClassifier}{ClassifierResults}(value)

\S4method{getClassifier}{character}(value)
}
\arguments{
\item{value}{Either a text value indicating a classifier name
(see \code{\link{showClassifierList}}), or an object of
class \code{\link{ClassifierResults}} as returned by the
\code{\link{runClassifier}} function.}
}
\value{
The return value is a classifier definition which
is encoded in an object of class \code{\link{ClassifierParameters}}.
This can be used as input argument for the \code{\link{runClassifier}}
function.
}
\description{
\code{getClassifier} returns a requested classifier definition.
}
\examples{
getClassifier("EMC92")
}
\seealso{
\code{\link{ClassifierParameters}} and \code{\link{runClassifier}}

Other classifier information functions: \code{\link{getCitations}},
  \code{\link{getDecisionBoundaries}},
  \code{\link{getDescription}},
  \code{\link{getEventChain}}, \code{\link{getIntercept}},
  \code{\link{getMeans}},
  \code{\link{getNormalizationMethod}},
  \code{\link{getProbeNames}}, \code{\link{getSds}},
  \code{\link{getTrainingData}}, \code{\link{getWeights}}
}
\concept{classifier information functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allGenericFunctions.R,
%   R/Class_ClassifierResults.R
\docType{methods}
\name{getClassifications}
\alias{getClassifications}
\alias{getClassifications,ClassifierResults-method}
\title{Obtain classifier classifications.}
\usage{
getClassifications(object)

\S4method{getClassifications}{ClassifierResults}(object)
}
\arguments{
\item{object}{An object of class \code{\link{ClassifierResults}}}
}
\value{
A vector of orderd factors with classifications per sample
}
\description{
\code{getClassifications} returns the resulting classifications.
}
\examples{
myData <- setNormalizationMethod(exampleMAS5, "MAS5.0",targetValue=500)
results <- runClassifier('EMC92', myData)
getScores( results )
getClassifications( results )
}
\seealso{
Other classifier results: \code{\link{getBatchCorrection}},
  \code{\link{getScores}}, \code{\link{getWeightingType}}
}
\concept{classifier results}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allGenericFunctions.R,
%   R/Class_FixedExpressionData.R
\docType{methods}
\name{getTargetValue}
\alias{getTargetValue}
\alias{getTargetValue,FixedExpressionData-method}
\title{Obtain the targetValue}
\usage{
getTargetValue(object)

\S4method{getTargetValue}{FixedExpressionData}(object)
}
\arguments{
\item{object}{An object of class \code{\link{FixedExpressionData}}}
}
\value{
A numeric value
}
\description{
\code{getTargetValue} returns the current applied targetValue
in the MAS5.0 gene expression data.
}
\examples{
data(exampleMAS5)
myData <- setNormalizationMethod(exampleMAS5, "MAS5.0", targetValue=500)
getTargetValue( myData )
}
\seealso{
Other fixed data information extraction functions: \code{\link{[,FixedExpressionData,ANY,ANY-method}},
  \code{\link{dim,FixedExpressionData-method}},
  \code{\link{getNormalizationMethod}}
}
\concept{fixed data information extraction functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allGenericFunctions.R,
%   R/Class_FixedExpressionData.R, R/Class_ClassifierParameters.R
\docType{methods}
\name{getNormalizationMethod}
\alias{getNormalizationMethod}
\alias{getNormalizationMethods}
\alias{getNormalizationMethod,FixedExpressionData-method}
\alias{getNormalizationMethod,ClassifierParameters-method}
\title{Obtain normalization method}
\usage{
getNormalizationMethod(object)

getNormalizationMethods()

\S4method{getNormalizationMethod}{FixedExpressionData}(object)

\S4method{getNormalizationMethod}{ClassifierParameters}(object)
}
\arguments{
\item{object}{An object of class \code{\link{FixedExpressionData}} or
\code{\link{ClassifierParameters}}}
}
\value{
A character string indicating the normalization method.
}
\description{
The function \code{getNormalizationMethod} returns the normalization method
associated with the object

\code{getNormalizationMethods} returns a character vector of 
currenlty available normalization methods.
}
\details{
The given normlization methods can be used in the
}
\examples{
data(exampleMAS5)
myData <- setNormalizationMethod(exampleMAS5, "MAS5.0", targetValue=500)
aClassifier <- getClassifier("EMC92")
getNormalizationMethod( myData )
getNormalizationMethod( aClassifier )
data(exampleMAS5)

showClassifierList()
getNormalizationMethods()

myData <- setNormalizationMethod(exampleMAS5, "MAS5.0",targetValue=500)
results <- runClassifier('UAMS70', myData)

getScores( results )
getClassifications( results )

}
\seealso{
\code{\link{getNormalizationMethods}}

Other classifier information functions: \code{\link{getCitations}},
  \code{\link{getClassifier}},
  \code{\link{getDecisionBoundaries}},
  \code{\link{getDescription}},
  \code{\link{getEventChain}}, \code{\link{getIntercept}},
  \code{\link{getMeans}}, \code{\link{getProbeNames}},
  \code{\link{getSds}}, \code{\link{getTrainingData}},
  \code{\link{getWeights}}

Other fixed data information extraction functions: \code{\link{[,FixedExpressionData,ANY,ANY-method}},
  \code{\link{dim,FixedExpressionData-method}},
  \code{\link{getTargetValue}}

Other workflow functions: \code{\link{runClassifier}},
  \code{\link{setNormalizationMethod}},
  \code{\link{showClassifierList}}
}
\concept{classifier information functions}
\concept{fixed data information extraction functions}
\concept{workflow functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allGenericFunctions.R,
%   R/Class_ClassifierParameters.R
\docType{methods}
\name{getCitations}
\alias{getCitations}
\alias{getCitations,ClassifierParameters-method}
\title{Obtain citations to the classifier}
\usage{
getCitations(object)

\S4method{getCitations}{ClassifierParameters}(object)
}
\arguments{
\item{object}{An object of class \code{\link{ClassifierParameters}}
as returned by \code{\link{getClassifier}}}
}
\value{
A character vector
}
\description{
\code{getCitations} Obtain citations to the classifier
}
\examples{
aClassifier <- getClassifier("EMC92")
getCitations(aClassifier)
}
\seealso{
Other classifier information functions: \code{\link{getClassifier}},
  \code{\link{getDecisionBoundaries}},
  \code{\link{getDescription}},
  \code{\link{getEventChain}}, \code{\link{getIntercept}},
  \code{\link{getMeans}},
  \code{\link{getNormalizationMethod}},
  \code{\link{getProbeNames}}, \code{\link{getSds}},
  \code{\link{getTrainingData}}, \code{\link{getWeights}}
}
\concept{classifier information functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/geneClassifiers.R
\docType{package}
\name{geneClassifiers-package}
\alias{geneClassifiers}
\alias{geneClassifiers-package}
\title{geneClassifiers: Application of gene classifiers}
\description{
This packages aims for easy accessible application of
        classifiers which have been published in literature using an
        ExpressionSet as input.
}
\details{
Combining gene expression profiling data with survival data has led to the 
development of robust outcome predictors (gene classifiers).This package 
provides a method for running gene classifiers generating patient specific 
predictive outcomes. This package is intended to support and enable 
research. To yield stable results, this package requires a dataset of
at least 20 patients.

For detail on how to use this package see the vignette: 
\code{vignette("geneClassifiers")}
}
\references{
Kuiper R, Broyl A, de Knegt YA, Van Vliet MH, Van Beers EH, van der Holt B, el Jarari L, Mulligan G, Gregory W, Morgan G, Goldschmidt H. A gene expression signature for high-risk multiple myeloma. Leukemia. 2012 Nov;26(11):2406.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://doi.org/doi:10.18129/B9.bioc.geneClassifiers}
  \item Report bugs at \url{https://github.com/rkuiper/geneClassifiers/issues}
}

}
\author{
\strong{Maintainer}: R Kuiper \email{r.kuiper.emc@gmail.com} (0000-0002-3703-1762)

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Class_FixedExpressionData.R
\docType{class}
\name{FixedExpressionData}
\alias{FixedExpressionData}
\title{An S4 class to store classifier parameters.}
\description{
This class stores gene expression data together with 
information on the normalization method and additional normalization related 
parameters. In order to ensure the data is not manipulated in unforeseen 
ways, manipulation is strictly controled through adding transformations 
which are predefined in the \code{TransformationProcess}-class. Upon reading
the data by the \code{exprs} function, the transformations areperformed in
the order the were added.
}
\section{Slots}{

\describe{
\item{\code{normalizationMethod}}{A character string indicating the normalization
method that was applied to the data. Possible values are give by 
\code{\link{getNormalizationMethods}}.}

\item{\code{expressionEnvironment}}{A locked environment in which the expression
matrix is stored.}

\item{\code{normalizationParameters}}{A list with normalization specific values.}

\item{\code{transformationProcess}}{A locked environment to which the transformation
processes are added.}

\item{\code{.geneClassifierVersion}}{An object of class \code{\link{package_version}}}
}}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allGenericFunctions.R,
%   R/Class_TransformationProcess.R, R/Class_ClassifierParameters.R,
%   R/Class_ClassifierResults.R
\docType{methods}
\name{getName}
\alias{getName}
\alias{getName,TransformationProcess-method}
\alias{getName,ClassifierParameters-method}
\alias{getName,ClassifierResults-method}
\title{Obtain object names.}
\usage{
getName(object)

\S4method{getName}{TransformationProcess}(object)

\S4method{getName}{ClassifierParameters}(object)

\S4method{getName}{ClassifierResults}(object)
}
\arguments{
\item{object}{The object to get the name of.}
}
\value{
The return value is a character string
}
\description{
\code{getName} returns the name associated with the requested object.
}
\examples{
aClassifier <- getClassifier("EMC92")
getName( aClassifier )
}
\seealso{
\code{\link{ClassifierParameters}}

\code{\link{ClassifierResults}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allGenericFunctions.R,
%   R/Class_ClassifierResults.R
\docType{methods}
\name{getScores}
\alias{getScores}
\alias{getScores,ClassifierResults-method}
\title{Obtain classifier score.}
\usage{
getScores(object)

\S4method{getScores}{ClassifierResults}(object)
}
\arguments{
\item{object}{An object of class \code{\link{ClassifierResults}}}
}
\value{
A numeric vector with scores per sample
}
\description{
\code{getScores} returns the resulting scores from a classifier
run
}
\examples{
data(exampleMAS5)
myData <- setNormalizationMethod(exampleMAS5, "MAS5.0", targetValue=500)
results <- runClassifier('EMC92', myData)
getScores( results )
getClassifications( results )
}
\seealso{
Other classifier results: \code{\link{getBatchCorrection}},
  \code{\link{getClassifications}},
  \code{\link{getWeightingType}}
}
\concept{classifier results}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Class_ClassifierResults.R
\docType{class}
\name{ClassifierResults}
\alias{ClassifierResults}
\title{An S4 class to store classifier results.}
\description{
This class stores classifier results as obtained after running
the \code{\link{runClassifier}} function.
}
\section{Slots}{

\describe{
\item{\code{classifierParameters}}{An object of class \code{\link{ClassifierParameters}}
in which the applied classifier parameters are stored.}

\item{\code{score}}{A numeric vector of resulting classifier scores}

\item{\code{batchCorrection}}{A character vector indicating wheter batch correction was applied}

\item{\code{weightingType}}{A character string indicating wheter the weighting type was complete
(i.e. no missing data), reweighted (i.e. missing data was handled based on correction
using the covariance structure in the classifiers training data), or reduced (i.e. missing
data but not reweighting the original probeset weighting)}

\item{\code{.geneClassifierVersion}}{An object of class \code{\link{package_version}}}
}}
